/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2009. All Rights Reserved. 
 * 
 * Note to U.S. Government Users Restricted Rights:  Use, 
 * duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.reports.scm.web.client.internal.ReportsClient");

dojo.require("com.ibm.team.repository.web.transport.ServiceRequest");
dojo.require("com.ibm.team.repository.web.transport.ServiceResponseHandler");
dojo.require("com.ibm.team.repository.web.transport.TeamServerClient");

(function() { // module container

var ServiceRequest 			= com.ibm.team.repository.web.transport.ServiceRequest;
var ServiceResponseHandler 	= com.ibm.team.repository.web.transport.ServiceResponseHandler;
var TeamServerClient 		= com.ibm.team.repository.web.transport.TeamServerClient;

com.ibm.team.reports.scm.web.client.internal.ReportsClient = {
	
	SERVICE_URI: "com.ibm.team.datawarehouse.service.scm.IReportScmRestService",
	
	/**
	 * Fetch all streams.
	 */
	getStreams: function(responseHandler) {
		this._invokeReportsService(responseHandler, "getStreams"); 
	},
	
	/**
	 * Save a stream.
	 */
	postSaveStreams: function(responseHandler, args) {
		this._invokeReportsService(responseHandler, "postSaveStreams", args);
	},
	
	/**
	 * Invokes the requested method on the REST service.
	 */
	_invokeReportsService: function(responseHandler, method, args) {
		// args is optional, so test whether or not it was sent
		var serviceRequest;
		if (arguments.length == 2) {
			serviceRequest = new ServiceRequest(
					this.SERVICE_URI,
					method);
		} else {
			serviceRequest = new ServiceRequest(
					this.SERVICE_URI,
					method,
					args);
		}
		TeamServerClient.invokeService(
				serviceRequest,
				responseHandler);
	}
};

})();