/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2009. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.apt.web.client.internal.SequenceSaveRunnable"); //$NON-NLS-1$

dojo.require("com.ibm.team.apt.web.ui.internal.common.Assert"); //$NON-NLS-1$
dojo.require("com.ibm.team.apt.web.client.internal.SaveRunnable"); //$NON-NLS-1$

(function() {

var Assert = com.ibm.team.apt.web.ui.internal.common.Assert;

dojo.declare("com.ibm.team.apt.web.client.internal.SequenceSaveRunnable", //$NON-NLS-1$
		[com.ibm.team.apt.web.client.internal.SaveRunnable], {
	
	__saveRunnables: null,
	
	constructor: function(saveRunnables) {
		Assert.isLegal(dojo.isArray(saveRunnables), "saveRunnables argument must be an array"); //$NON-NLS-1$
		this.__saveRunnables= saveRunnables;
	},

	save: function(successCallback, failureCallback) {
		this.__doSave(0, successCallback, failureCallback);
	},
	
	undo: function() {
		for (var i= this.__saveRunnables.length - 1; i >=0; i--) {
			this.__saveRunnables[i].undo();
		}
	},

	// ---- implementation -------------------------------------------------------------------------------------------------
	
	__doSave: function(index, successCallback, failureCallback) {
		if (index < this.__saveRunnables.length) {
			this.__saveRunnables[index].save(dojo.hitch(this, function() { 
				this.__doSave(index + 1, successCallback, failureCallback);
			}), dojo.hitch(this, function(report) { 
				try {
					for (var i= this.__saveRunnables.length - 1; i > index; i--) {
						this.__saveRunnables[i].undo();
					}
				} finally {
					failureCallback(report);
				}
			}));
		} else {
			successCallback();
		}
	},
	
	__sentinel: null // terminates this class definition
});

})();