/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2009. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.workitem.web.ui.internal.view.editor.parts.TimeSpentAttributePart");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.require("com.ibm.team.workitem.web.ui.internal.view.editor.parts.AbstractAttributePart");
dojo.require("com.ibm.team.workitem.web.ui.internal.view.layout.WidgetUtil");
dojo.require("com.ibm.team.workitem.web.ui.internal.view.layout.TextWidget");
dojo.requireLocalization("com.ibm.team.workitem.web.ui.internal", "WorkItemEditorMessages");
/*
 * This is a wrapper widget that provides the presentation and value
 * processing for Duration
 */
(function() {

var WidgetUtil = com.ibm.team.workitem.web.ui.internal.view.layout.WidgetUtil;
var TOOLTIP;

/* defineWidget */ dojo.declare(
	"com.ibm.team.workitem.web.ui.internal.view.editor.parts.TimeSpentAttributePart",
	[dijit._Widget, dijit._Templated, com.ibm.team.workitem.web.ui.internal.view.editor.parts.AbstractAttributePart],
	{
		
		templateString: '<div class="DurationAttributePart NarrowWidget">' +
						'</div>',
		constructor: function() {
			this.messages = dojo.i18n.getLocalization("com.ibm.team.workitem.web.ui.internal", "WorkItemEditorMessages");
			TOOLTIP= this.messages.msgDurationValidation;
		},
		postCreate: function() {
			/*
			 * values[0]
			 *    label
			 *    validationRegex
			 *    id
			 */
			
			if(this.values && this.values[0] && this.values[0]) {
				this.validationRegex = this.values[0].validationRegex;
				this.values = [ this.values[0].label ];
			} else {
				this.values = [ "" ]
			}
	
			var creationArgs = {
						parentWidget: this,
						parentController: this.parentController,
						presentation: {
							attribute: {
								attributeTypeId: "ShortString"
							}
						},
						selection:  [ {
							id: this.attributeValue.label
							} 
						 ] ,
						 converter: this._TextWidget_durationConverter,
						 converterParms: {
						 		toolTip: TOOLTIP,
								value: this.values[0]
						 },
						 valueChangedListener: this,
						 valueChangedFunction: "_valueChanged"
					};
					
			this.inputWidget = new com.ibm.team.workitem.web.ui.internal.view.layout.TextWidget(creationArgs);
			if(this.workingCopy.isGuest()) {
				dojo.addClass(this.inputWidget._textInput, "GuestField");
			}
			this.domNode.appendChild(this.inputWidget.domNode)
			this.workingCopy.addListener({
				path: ["attributes", "timeSpent"],
				event: "onchange",
				listener: this,
				functionName: "_handleAttributeChange"
			});
		},
		_handleAttributeChange: function(parms /* attributeValue, event, attributePath, itemProxy */ ) {
			this.inputWidget._textInput.value = parms.attributeValue;
		},
		_valueChanged: function(value) {
			this.workingCopy.setValue({
				path: ["attributes", "timeSpent"],
				attributeId: "timeSpent",
				value: value
			});
		},
		destroy: function() {
			if(this.inputWidget.destroy) this.inputWidget.destroy();
			this.inherited(arguments);
		},
		setReadOnly: function(isReadOnly) {
			this.inputWidget.setReadOnly(isReadOnly);
		},
//		getFormElementValues: function(formElements) {
//			var value = this.getValue();
//			if(value) {
//					formElements[this.attributeId] = value;
//				} else {
//					formElements[this.attributeId] = "";
//				}
//      },
		setFormElementValues: function(retainedState){
			var value = retainedState[this.attributeId];
			if(value) {
				this.inputWidget._textInput.value = value; // TODO: Create setValue API
			}
			},
	     getValue: function() {
			return this.inputWidget._textInput.value;
		 },
	//* This runs in the context of TextWidget
		//
		_TextWidget_durationConverter: function (value, parms, isGettingValidValue) {
			return this.parentWidget._durationConverter(value, parms, isGettingValidValue);
		},
		_durationConverter: function (value, parms, isGettingValidValue) {
			var valid = false;
			if(value) {
				try{
					var regex = new RegExp("^" + this.validationRegex + "$");
 					valid = value.search(regex) != -1;
//				valid = value.search(/^(([0-9]+(\.[0-9])?|\.[0-9]+)\s*(milliseconds|millisecond|millisecs|millisec|minutes|seconds|minute|second|weeks|hours|days|week|hour|mins|secs|day|wks|hrs|min|sec|ds|wk|ws|ms|d|w|h|m|s)\s*)*$/) != -1;
				} catch(e) {
					console.debug(dojo.string.substitute(this.messages.errorInvalidRegex, [this.validationRegex ]));
					valid = true;
				}

			}
			if(isGettingValidValue) {
				if(!value || value.length == 0) {
					return "";
				}				
				return value;
			}

			return {isCustom: true, isValid: valid };
		}
	}
);

})();
