/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2009. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.apt.web.ui.internal.view.plan.IterationPlanPage"); //$NON-NLS-1$

dojo.require("dijit._Widget"); //$NON-NLS-1$
dojo.require("dijit._Templated"); //$NON-NLS-1$

dojo.require("dojox.data.dom"); //$NON-NLS-1$

dojo.require("jazz.ui.HoverPopup"); //$NON-NLS-1$

dojo.require("com.ibm.team.repository.web.transport.ServiceResponseHandler"); //$NON-NLS-1$

dojo.require("com.ibm.team.apt.web.client.util"); //$NON-NLS-1$
dojo.require("com.ibm.team.apt.web.client.internal.PlanningClient"); //$NON-NLS-1$
dojo.require("com.ibm.team.apt.web.client.internal.ImageClient"); //$NON-NLS-1$
dojo.require("com.ibm.team.apt.web.client.internal.PlanExtensionRegistry"); //$NON-NLS-1$

dojo.require("com.ibm.team.apt.web.ui.internal.common.UI"); //$NON-NLS-1$
dojo.require("com.ibm.team.apt.web.ui.internal.common.Assert"); //$NON-NLS-1$
dojo.require("com.ibm.team.apt.web.ui.internal.common.ReferencedItemStore"); //$NON-NLS-1$
dojo.require("com.ibm.team.apt.web.ui.internal.view.plan.TabPlannedItems"); //$NON-NLS-1$
dojo.require("com.ibm.team.apt.web.ui.internal.view.plan.TabContributedPage"); //$NON-NLS-1$
dojo.require("com.ibm.team.apt.web.ui.internal.common.QueryDescriptor"); //$NON-NLS-1$

dojo.require("com.ibm.team.apt.web.ui.internal.view.search.IterationPlanBanner"); //$NON-NLS-1$

dojo.require("com.ibm.team.apt.web.ui.internal.view.plan.PlanConfigurationPart"); //$NON-NLS-1$

dojo.require("com.ibm.team.apt.web.ui.internal.view.widgets.ProgressBar"); //$NON-NLS-1$
dojo.require("com.ibm.team.apt.web.ui.internal.view.widgets.RelatedPlansWidget"); //$NON-NLS-1$

dojo.require("com.ibm.team.apt.web.ui.internal.view.plan.actions.ToolBarManager"); //$NON-NLS-1$
dojo.require("com.ibm.team.apt.web.ui.internal.view.plan.actions.RefreshPlanAction"); //$NON-NLS-1$
dojo.require("com.ibm.team.apt.web.ui.internal.view.plan.actions.SavePlanAction"); //$NON-NLS-1$
dojo.require("com.ibm.team.apt.web.ui.internal.view.plan.actions.Separator"); //$NON-NLS-1$
dojo.require("com.ibm.team.apt.web.ui.internal.view.plan.actions.AddAttachedPageAction"); //$NON-NLS-1$
dojo.require("com.ibm.team.apt.web.ui.internal.view.plan.actions.DeleteAttachedPageAction"); //$NON-NLS-1$


dojo.require("dojo.string"); //$NON-NLS-1$
dojo.require("dojo.i18n"); //$NON-NLS-1$
dojo.requireLocalization("com.ibm.team.apt.web.ui.internal", "IterationPlanMessages"); //$NON-NLS-1$ //$NON-NLS-2$

(function() {

var UI						= com.ibm.team.apt.web.ui.internal.common.UI;
var Assert					= com.ibm.team.apt.web.ui.internal.common.Assert;

var PlanningUtil			= com.ibm.team.apt.web.client.util;
var PlanningClient= com.ibm.team.apt.web.client.internal.PlanningClient;
var ImageClient				= com.ibm.team.apt.web.client.internal.ImageClient;
var PlanExtensionRegistry	= com.ibm.team.apt.web.client.internal.PlanExtensionRegistry;
var ProgressBar				= com.ibm.team.apt.web.ui.internal.view.widgets.ProgressBar;
var TabPlannedItems			= com.ibm.team.apt.web.ui.internal.view.plan.TabPlannedItems;
var TabAttachedPage			= com.ibm.team.apt.web.ui.internal.view.plan.TabAttachedPage;
var TabContributedPage		= com.ibm.team.apt.web.ui.internal.view.plan.TabContributedPage;
var IterationPlanBanner		= com.ibm.team.apt.web.ui.internal.view.search.IterationPlanBanner;
var ReferencedItemStore		= com.ibm.team.apt.web.ui.internal.common.ReferencedItemStore;

var ToolBarManager			= com.ibm.team.apt.web.ui.internal.view.plan.actions.ToolBarManager;
var SavePlanAction			= com.ibm.team.apt.web.ui.internal.view.plan.actions.SavePlanAction;
var RefreshPlanAction		= com.ibm.team.apt.web.ui.internal.view.plan.actions.RefreshPlanAction
var Separator				= com.ibm.team.apt.web.ui.internal.view.plan.actions.Separator;
var AddAttachedPageAction 	= com.ibm.team.apt.web.ui.internal.view.plan.actions.AddAttachedPageAction;
var DeleteAttachedPageAction= com.ibm.team.apt.web.ui.internal.view.plan.actions.DeleteAttachedPageAction;

var replaceChildren			= dojox.data.dom.replaceChildren;
var removeChildren			= dojox.data.dom.removeChildren;

var bind= dojo.string.substitute;
var MSGS= dojo.i18n.getLocalization("com.ibm.team.apt.web.ui.internal", "IterationPlanMessages"); //$NON-NLS-1$ //$NON-NLS-2$

dojo.declare("com.ibm.team.apt.web.ui.internal.view.plan.IterationPlanPage", //$NON-NLS-1$
			 [dijit._Widget, dijit._Templated], {

	// ---- constructor mixed-in properties --------------------------------------------------------------------------------	

	_iterationPlanDTO: null,
	_referencedItems: null,
	_serviceCallController: null,
	
	_metaNav: null,
	_typeIcon: null,
	_planName: null,
	_errorSpan: null,
	_infoBarTeamArea: null,
	_infoBarIteration: null,
	_infoBarClosedItems: null,
	_infoBarOpenItems: null,
	
	_progressArea: null,
	_nodeProgressBar: null,
	_progressBar: null, //widget
	_progressHours: null,
	_progressQuality: null,
	
	__progressInformation: null,
	__progressLabelProvider: null,
	
	_tabLinkContainer: null,
	_tabContent: null,
	
	_labelDefaultTitle : MSGS.ITERATIONPLAN_DEFAULTTITLE,
	_labelTeamArea : MSGS.ITERATIONPLAN_TEAMAREA,
	_labelDevLine : MSGS.ITERATIONPLAN_DEVLINE,
	_labelIteration : MSGS.ITERATIONPLAN_ITERATION,
	_titleRefreshPlan : MSGS.ITERATIONPLAN_REFRESH_TITLE,
	_altRefreshPlan : MSGS.ITERATIONPLAN_REFRESH_ALT,
	_messages: MSGS,
	
	constructor: function() {
		this._tabWidgets= new Object();
		this._currentTabId= null;
	},

	// ---- api ------------------------------------------------------------------------------------------------------------	

	getPlanId: function() {
		return this._iterationPlanDTO.itemId;
	},

	getTitle: function() {
		return bind(MSGS.ITERATIONPLAN_PAGETITLE, [this.getDecoratedPlanLabel()]);
	},

	getDecoratedPlanLabel: function() {
		return bind(MSGS.ITERATIONPLAN_PLAN_LABEL, [this._iterationPlanDTO.label, this._getIteration().label]);
	},

	getPlanIcon: function() {
		return ImageClient.getImageUrl(this._iterationPlanDTO.iconURL);
	},
	
	showErrorMessage: function(title, description) {
		var children= this._errorSpan.childNodes;
		for ( var i = 0; i < children.length; i++) {
			this._errorSpan.removeChild(children[i]);
			
			delete children[i];
		}
		
		if (!title)
			return;
		
		var message;
		if (description) {
			message= bind(MSGS.ITERATIONPLAN_ERROR_MESSAGE_WITH_DESCRIPTION, [title, description]);
		} else {
			message= title;
		}
		
		this._errorSpan.appendChild(document.createTextNode(message));		
	},
	
	setViewOptions: function(viewOptions, searchResults) {
		var pageId= viewOptions["page"]; //$NON-NLS-1$
		Assert.isLegal(pageId != null);
		
		if (this._setCurrentTab(pageId)) {
			var currentTab= this._getCurrentTab();
			Assert.isNotNull(currentTab);
			
			currentTab.setViewOptions(viewOptions);
		}
		
		if (searchResults != null) {
			var metaNav= new IterationPlanBanner(IterationPlanBanner.constructorArgs(this._iterationPlanDTO, searchResults, viewOptions));
			replaceChildren(this._metaNav, metaNav.domNode);
		} else {
			removeChildren(this._metaNav);
		}
	},

	getViewOptions: function() {
		var currentTab= this._getCurrentTab();
		
		if (currentTab == null)
			return {};
		
		return dojo.mixin({ page: currentTab.getId() }, currentTab.getViewOptions());
	},
	
	getIncludedIterations: function() {
		return dojo.map(this._iterationPlanDTO.includedIterations, function(iteration) {
			return this._getItem(ReferencedItemStore.ITEM_TYPES.ITERATION, iteration);
		}, this);
	},
	
	getIncludedTeamMemberAreas: function() {
		return dojo.map(this._iterationPlanDTO.includedTeamMemberAreas, function(memberArea) {
			return this._getItem(ReferencedItemStore.ITEM_TYPES.TEAMAREA, memberArea) || this._getItem(ReferencedItemStore.ITEM_TYPES.PROJECTAREA, memberArea);
		}, this);
	},
	
	// ---- widget implementation ------------------------------------------------------------------------------------------

	templatePath: dojo.moduleUrl("com.ibm.team.apt.web", "ui/internal/view/plan/templates/IterationPlanPage.html"), //$NON-NLS-1$ //$NON-NLS-2$

	postCreate: function() {
		
		new com.ibm.team.apt.web.ui.internal.view.widgets.RelatedPlansWidget({planRecord: this._iterationPlanDTO}, this._nodeRelatedPlans);
		
		var styles= {};
		styles.disabled= "exclude";  //$NON-NLS-1$
		this._toolBar= new ToolBarManager(styles);
		this._toolBar.add(new Separator());
		this._toolBar.add(new AddAttachedPageAction(this._serviceCallController, this));
		this._toolBar.add(new RefreshPlanAction(this._serviceCallController, this));
		this._toolBar.create(this._nodeToolBar); //$NON-NLS-1$
		this._toolBar.update(); 
		
		var constructorArgs;
		var i;
		
		var img= document.createElement("img"); // $NON-NLS-1$
		img.src= this.getPlanIcon();
		this._typeIcon.appendChild(img);
//		this._typeIcon.src= this.getPlanIcon();	
		replaceChildren(this._planName, document.createTextNode(this._iterationPlanDTO.label));
		
		var teamArea= this._getTeamArea();
		var iteration= this._getIteration();
		
		this._infoBarTeamArea.appendChild(document.createTextNode(teamArea.label));
		
		var iterationLabel= iteration.label;
		
		var startDateLabel= PlanningUtil.formatDate(iteration.startDate, null, "short"); //$NON-NLS-1$
		var endDateLabel= PlanningUtil.formatDate(iteration.endDate, null, "short"); //$NON-NLS-1$
		if (startDateLabel && endDateLabel) {
			iterationLabel= bind(MSGS.ITERATIONPLAN_ITERATIONLABEL_WITH_DATES, [iteration.label, startDateLabel, endDateLabel]);
		}

		this._infoBarIteration.appendChild(document.createTextNode(iterationLabel));

		PlanningUtil.runWithCondition(dojo.hitch(this, function() {
			if(!this._iterationPlanDTO.teamLoad)
				return;
			
			var options= {};
			options.parameters= {};
			if(this._iterationPlanDTO.teamLoad.complexityAttribute){
				options.parameters["complexityLabel"]= this._iterationPlanDTO.teamLoad.complexityAttribute.label; //$$NON-NLS-1$
				options.parameters["complexityUnit"]= this._iterationPlanDTO.teamLoad.complexityAttribute.unit; //$NON-NLS-1$
			}
			
			this.__progressInformation= new com.ibm.team.apt.client.DTOBasedProgressInformation(-1, -1, this._iterationPlanDTO.teamLoad);
			var labelProviderCtor= dojo.getObject(this._iterationPlanDTO.teamLoad.labelProviderImplementation);
			this.__progressLabelProvider= new labelProviderCtor(options);
			constructorArgs= ProgressBar.constructorArgs(this.__progressInformation, this.__progressLabelProvider, "100%", "1.5em"); //$NON-NLS-1$ //$NON-NLS-2$
			this._progressBar= new ProgressBar(constructorArgs, this._nodeProgressBar);
			this._progressHours.innerHTML= this.__progressLabelProvider.getProgressText(this.__progressInformation);
			this._progressQuality.innerHTML= this.__progressLabelProvider.getQualityText(this.__progressInformation);
			
			this._infoBarClosedItems.appendChild(document.createTextNode(bind(MSGS.ITERATIONPLAN_CLOSEDITEMS, [this.__progressInformation.getCloseCount()])));
			this._infoBarOpenItems.appendChild(document.createTextNode(bind(MSGS.ITERATIONPLAN_OPENITEMS, [this.__progressInformation.getOpenCount()])));

			
		}), PlanningClient.getScriptsLoadedCondition());
		
		if(this._editData.isValid())
			return;
		
		var planTabs= [];
		
		constructorArgs= TabPlannedItems.constructorArgs(this, null, this._serviceCallController);
		planTabs.push(new TabPlannedItems(constructorArgs));
		
		for (i = 0; i < this._iterationPlanDTO.attachedPages.length; i++) {
			var attachedPage = this._getItem(ReferencedItemStore.ITEM_TYPES.WIKIPAGE, this._iterationPlanDTO.attachedPages[i]);

			constructorArgs= TabAttachedPage.constructorArgs(this, attachedPage, null, this._serviceCallController);
			planTabs.push(new TabAttachedPage(constructorArgs));
		}
		
		dojo.forEach(PlanExtensionRegistry.getContributedTabs(), dojo.hitch(this, function(tabDescription) {
			if (tabDescription.id != "com.ibm.team.reports.web.charts" || this._iterationPlanDTO.showChartPage) { //$NON-NLS-1$
				constructorArgs= TabContributedPage.constructorArgs(this, tabDescription.id, tabDescription.name, tabDescription.widgetId, this._serviceCallController);
				planTabs.push(new TabContributedPage(constructorArgs));
			}
		}));

		this._sortTabs(planTabs);
		
		for (i= 0; i < planTabs.length; i++) {
			this._addTab(planTabs[i], i == 0);
		}
	},
	
	destroy: function() {
		var tabsToDestory= this._tabWidgets;
		this._tabWidgets= null;
		for (var tabName in tabsToDestory) {
			tabsToDestory[tabName].destroy();
		}

		this.inherited(arguments);
	},
	
	onPageShow: function() {
		var currentTab= this._getCurrentTab();
		if (currentTab == null)
			return;
		
		currentTab.widgetAboutToShow();
	},
	
	getProgressInformation: function() {
		return this.__progressInformation;
	},
	
	updateProgress: function() {
		this._progressBar.update();
		this._progressHours.innerHTML= this.__progressLabelProvider.getProgressText(this.__progressInformation);
		this._progressQuality.innerHTML= this.__progressLabelProvider.getQualityText(this.__progressInformation);
	},
	
	getPlanRecord: function() {
		return this._iterationPlanDTO;
	}, 
	
	// ---- implementation -------------------------------------------------------------------------------------------------
	
	_getPlanViewUrl: function(viewOptions) {
		return PlanningUtil.getPlanViewURI(this._iterationPlanDTO.itemId, viewOptions || {});
	},

	_getIteration: function() {
		return this._iterationPlanDTO.getIteration();
	},

	_getTeamArea: function() {
		return this._iterationPlanDTO.getTeamArea();
	},

	_getItem: function(type, id) {
		return this._referencedItems.getItem(type, id);
	},
	
	_getAttachedPages: function(){
		return dojo.map(this._iterationPlanDTO.attachedPages, dojo.hitch(this, function(page) { return this._getItem(ReferencedItemStore.ITEM_TYPES.WIKIPAGE, page)}));
	},
	
	_removeAttachedPage: function(pageId){
		var index= dojo.indexOf(this._iterationPlanDTO.attachedPages, pageId);
		if(index >= 0){
			this._iterationPlanDTO.attachedPages.splice(index, 1);	
		}
	},
	
	// ---- tabs implementation --------------------------------------------------------------------------------------------
	
	_addTab: function(tabWidget, isFirst) {
		var tabId= tabWidget.getId();
		
		var link = document.createElement("a"); //$NON-NLS-1$
		dojo.addClass(link,"tab"); //$NON-NLS-1$
		link.href = this._getPlanViewUrl({ page : tabId });
		
		var innerWrapper = document.createElement("div"); //$NON-NLS-1$
		innerWrapper.className = "innerWrapper"; //$NON-NLS-1$
		
		var topWrapper = document.createElement("div"); //$NON-NLS-1$
		topWrapper.className = "topWrapper"; //$NON-NLS-1$
		
		var topBorderDiv = document.createElement("div"); //$NON-NLS-1$
		topBorderDiv.className = "topBorder"; //$NON-NLS-1$
		topWrapper.appendChild(topBorderDiv);
		
		var cornerDiv = document.createElement("div"); //$NON-NLS-1$
		cornerDiv.className = "corners"; //$NON-NLS-1$
		topWrapper.appendChild(cornerDiv);
								
		link.appendChild(topWrapper);
		link.title = tabWidget.getTitle();
		
		var titleDiv = document.createElement("div"); //$NON-NLS-1$
		titleDiv.className = "title"; //$NON-NLS-1$
		titleDiv.appendChild(document.createTextNode(tabWidget.getTitle()));
		innerWrapper.appendChild(titleDiv);

		link.appendChild(innerWrapper);
		this._tabLinkContainer.appendChild(link);

		tabWidget.tabNode(link);
		this._tabWidgets[tabId]= tabWidget;
	},
	
	_removeTab: function(tabWidget) {
		if (this._tabWidgets != null) {
			var tabId= tabWidget.getId();
			var tab= tabWidget.tabNode();
			tab.parentNode.removeChild(tab);
			
			var nextTabId;
			for(var prop in this._tabWidgets) {
				if(prop != tabId) {
					nextTabId= prop;
					break;
				}
			}
			
			delete this._tabWidgets[tabId];
			if (nextTabId) {
				this._setCurrentTab(nextTabId);		
			}
		}
	},
	
	_setCurrentTab: function(tabId) {
		if (this._currentTabId == tabId)
			return true;
			
		Assert.isLegal(tabId, "tabId"); //$NON-NLS-1$
		
		var tabWidget= this._tabWidgets[tabId];
		if (!dojo.isObject(tabWidget)) {
			return false;
		}
		
		dojo.query(".Selected", this._tabLinkContainer).removeClass("Selected"); //$NON-NLS-1$ //$NON-NLS-2$
		dojo.addClass(tabWidget.tabNode(), "Selected"); //$NON-NLS-1$ //$NON-NLS-2$

		dojox.data.dom.removeChildren(this._tabContent);
		this._tabContent.appendChild(tabWidget.domNode);
		
		tabWidget.widgetAboutToShow();
		this._currentTabId= tabId;
		
		return true;
	},
	
	_getCurrentTab: function() {
		return this._currentTabId != null ? this._tabWidgets[this._currentTabId] : null;
	},
	
	_sortTabs: function(tabWidgets) {
		var computeCategory= function(tab) {
			switch (tab.declaredClass) {
				case "com.ibm.team.apt.web.ui.internal.view.plan.TabAttachedPage": //$NON-NLS-1$
					return tab.getId() == "overview" ? 1 : 4; //$NON-NLS-1$
				case "com.ibm.team.apt.web.ui.internal.view.plan.TabPlannedItems": //$NON-NLS-1$
					return 2;
				case "com.ibm.team.apt.web.ui.internal.view.plan.TabContributedPage": //$NON-NLS-1$
					return 3;
				default:
					return 4;
			}
		};

		tabWidgets.sort(function(a, b) {
			var result= computeCategory(a) - computeCategory(b);
			if (result != 0)
				return result;
			
			return a.getTitle().localeCompare(b.getTitle());
		});
	},
		
	isEditMode: function() {
		return Boolean(this.__editMode);
	},
	
	setEditMode: function(editMode){
		if(!this._editData.isValid()){
			return;
		}
		if(this.__editMode == editMode) {
			return;
		}
		this.__editMode= editMode;
		
		dojo.toggleClass(this._nodePlanConfigurationPart, "exclude"); //$NON-NLS-1$
		dojo.toggleClass(this._nodePlanHeader, "exclude"); //$NON-NLS-1$
		var params= {
			saveAction: new SavePlanAction(this._serviceCallController, this),
			editData: this._editData
		};
		new com.ibm.team.apt.web.ui.internal.view.plan.PlanConfigurationPart(params, this._nodePlanConfigurationPart);
	},
	
	setDirty: function(dirty){
		this._toolBar.update("exclude"); //$NON-NLS-1$
	},
	
	__sentinel: null // terminates this class definition
});

/**
 * This helper method creates the arguments object for the widget's constructor.
 * @param {LoadIterationPlanResultDTO} loadIterationPlanResultDTO the DTO carrying the IterationPlanDTO and its referenced items 
 * @return {Object} a widget private object to be passed in as a constructor argument
 */
com.ibm.team.apt.web.ui.internal.view.plan.IterationPlanPage.constructorArgs= function(loadIterationPlanResultDTO, serviceCallController) {
	var result= {
		_iterationPlanDTO: loadIterationPlanResultDTO.plan,
		_referencedItems: loadIterationPlanResultDTO._referencedItemStore,
		_serviceCallController: serviceCallController
	};
	
	if (loadIterationPlanResultDTO.initialPage) {
		result["_pageData"]["initial"]= loadIterationPlanResultDTO.initialPage; //$NON-NLS-1$ //$NON-NLS-2$
	}
	
	var editData= {};
	editData.name= loadIterationPlanResultDTO.plan.label;
	editData.planTypeId= loadIterationPlanResultDTO.plan.planTypeId;
	editData.alwaysLoadAllExecutionItems= loadIterationPlanResultDTO.plan.alwaysLoadAllExecutionItems;
	editData.processArea= loadIterationPlanResultDTO.plan.getTeamArea();
	editData.iteration= loadIterationPlanResultDTO.plan.getIteration();
	editData.planTypes= loadIterationPlanResultDTO.planTypes;
	editData.associatedProcessAreas= loadIterationPlanResultDTO.associatedProcessAreas;
	editData.isValid= function() {
		return loadIterationPlanResultDTO.projectArea != null && loadIterationPlanResultDTO.planTypes != null;
	};
	editData.canSave= function(){
		return this.name != null && String(this.name).length != 0 && this.processArea != null && this.iteration != null;
	};
	result["_editData"]= editData; //$NON-NLS-1$

	return result;
};

})();
