/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2009. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.apt.web.ui.internal.view.plan.TabAttachedPage"); //$NON-NLS-1$

dojo.require("dijit._Templated"); //$NON-NLS-1$

dojo.require("dojox.data.dom"); //$NON-NLS-1$

dojo.require("com.ibm.team.apt.web.client.util"); //$NON-NLS-1$
dojo.require("com.ibm.team.apt.web.client.internal.ImageClient"); //$NON-NLS-1$
dojo.require("com.ibm.team.apt.web.client.internal.PlanningClient"); //$NON-NLS-1$

dojo.require("com.ibm.team.apt.web.ui.internal.view.plan.Tab"); //$NON-NLS-1$
dojo.require("com.ibm.team.apt.web.ui.internal.common.UI"); //$NON-NLS-1$

dojo.require("com.ibm.team.apt.web.ui.internal.view.plan.actions.ToolBarManager"); //$NON-NLS-1$
dojo.require("com.ibm.team.apt.web.ui.internal.view.plan.actions.Separator"); //$NON-NLS-1$
dojo.require("com.ibm.team.apt.web.ui.internal.view.plan.actions.EditAttachedPageAction"); //$NON-NLS-1$
dojo.require("com.ibm.team.apt.web.ui.internal.view.plan.actions.DeleteAttachedPageAction"); //$NON-NLS-1$
dojo.require("com.ibm.team.apt.web.ui.internal.view.plan.actions.SaveAttachedPageAction"); //$NON-NLS-1$

dojo.require("dojo.string"); //$NON-NLS-1$
dojo.require("dojo.i18n"); //$NON-NLS-1$
dojo.requireLocalization("com.ibm.team.apt.web.ui.internal", "IterationPlanMessages"); //$NON-NLS-1$ //$NON-NLS-2$

(function() {

var PlanningUtil		= com.ibm.team.apt.web.client.util;
var ImageClient			= com.ibm.team.apt.web.client.internal.ImageClient;
var UI= com.ibm.team.apt.web.ui.internal.common.UI;
var PlanningClient		= com.ibm.team.apt.web.client.internal.PlanningClient;
var ResponseHandler		= com.ibm.team.apt.web.client.internal.ProgressMonitoredServiceResponseHandler;
var Tab					= com.ibm.team.apt.web.ui.internal.view.plan.Tab;

var ToolBarManager			= com.ibm.team.apt.web.ui.internal.view.plan.actions.ToolBarManager;
var Separator				= com.ibm.team.apt.web.ui.internal.view.plan.actions.Separator;
var DeleteAttachedPageAction= com.ibm.team.apt.web.ui.internal.view.plan.actions.DeleteAttachedPageAction;
var EditAttachedPageAction 	= com.ibm.team.apt.web.ui.internal.view.plan.actions.EditAttachedPageAction;
var SaveAttachedPageAction 	= com.ibm.team.apt.web.ui.internal.view.plan.actions.SaveAttachedPageAction;

var removeChildren= dojox.data.dom.removeChildren;
var bind= dojo.string.substitute;
var MSGS= dojo.i18n.getLocalization("com.ibm.team.apt.web.ui.internal", "IterationPlanMessages"); //$NON-NLS-1$ //$NON-NLS-2$

dojo.declare("com.ibm.team.apt.web.ui.internal.view.plan.TabAttachedPage", //$NON-NLS-1$
			 [com.ibm.team.apt.web.ui.internal.view.plan.Tab, dijit._Templated], {

	// ---- constructor mixed-in properties --------------------------------------------------------------------------------	

	_pageId: null,
	_pageStateId: null,
	_planId: null,
	_pageContent: null,
	_wikiSource: null, 
	
	_toolBar: null,
	
	_actionBar: null,
	_wikiStatus: null,
	_wikiView: null,
	_wikiEdit: null,
	_wikiEditor: null, 
	
	_editMode: null,
	_isDirty: null,	
	_isEditable: null,
	_attachedPageContent: null,

	constructor: function() {
		this._notYetShown= true;
	},

	// ---- api ------------------------------------------------------------------------------------------------------------	
	
	getPageId: function() {
		return this._pageId;
	},
	
	getPageStateId: function() {
		return this._pageStateId;
	},
	
	getPlanPage: function() {
		return this._iterationPlanPage;
	},
	
	getEditMode: function() {
		return this._editMode;
	},
	
	setEditMode: function(editMode){
		
		if(!editMode){
			var self= this;
			var serviceCallback= {
				_success: function(result) {
					self._displayAttachedPageContent(result.wikiSource, result.pageContent);
				},
				_error: function(error) {
					self._serviceCallController.remoteError(error);
				}
			}
			var responseHandler= new ResponseHandler(serviceCallback, "_success", "_error"); //$NON-NLS-1$ //$NON-NLS-2$
			responseHandler.setLabel(MSGS.MONITOR_PREVIEW_ATTACHEDPAGE, this._serviceCallController);
			PlanningClient.previewAttachedPage(responseHandler, this.getPlanPage().getPlanId(), this.getPageId(), this._wikiEditor.value);
		}
		
		UI.exclude(editMode ? this._wikiView : this._wikiEdit);
		UI.include(editMode ? this._wikiEdit : this._wikiView);
		this._editMode= editMode;
		this._toolBar.update();
	},
	
	isEditable: function() {
		return this._isEditable;
	},
	
	isDirty: function() {
		return this._isDirty;
	},
	
	setDirty: function(value) {
		this._isDirty= value;
	},
	
	// ---- widget implementation ------------------------------------------------------------------------------------------

	templatePath: dojo.moduleUrl("com.ibm.team.apt.web", "ui/internal/view/plan/templates/TabAttachedPage.html"), //$NON-NLS-1$ //$NON-NLS-2$

	postCreate: function() {
	
		this.connect(this._wikiEditor, "onkeyup", "_onTextChange"); //$NON-NLS-1$ //$NON-NLS-2$

		this._toolBar= new ToolBarManager();
		this._toolBar.add(new EditAttachedPageAction(this._serviceCallController, this));
		this._toolBar.add(new DeleteAttachedPageAction(this._serviceCallController, this));
		this._toolBar.add(new Separator());
		this._toolBar.add(new SaveAttachedPageAction(this._serviceCallController, this));
		this._toolBar.create(this._actionBar); //$NON-NLS-1$ 
		this._toolBar.update();
	},

	// ---- Tab.js implementation ------------------------------------------------------------------------------------------

	widgetAboutToShow: function() {
		this._editMode= false;
		if (this._notYetShown) {
			if (this._rootGroup == null) {
				var serviceCallController= this._getServiceCallController(); 
				
				var _self= this;
				var serviceCallback= {
					_success: function(result) {
						_self._displayAttachedPageContent(result.wikiSource, result.pageContent, result.stateId);
					},
					_error: function(error) {
						serviceCallController.remoteError(error);
					}
				}
				
				var responseHandler= new ResponseHandler(serviceCallback, "_success", "_error"); //$NON-NLS-1$ //$NON-NLS-2$
				responseHandler.setLabel(MSGS.MONITOR_LOAD_ATTACHEDPAGE, serviceCallController);		
				PlanningClient.fetchAttachedPage(responseHandler, this._planId, this._pageId);

			} else {
				this._displayAttachedPageContent(this._pageContent);
			}

			this._notYetShown= false;
		}
	},
	
	// ---- implementation -------------------------------------------------------------------------------------------------

	_displayAttachedPageContent: function(wikiSource, pageContent, stateId) {
		this._pageContent= pageContent;
		this._wikiSource= wikiSource;
		this._pageStateId= stateId || this._pageStateId;
		
		if(wikiSource != null){
			UI.exclude(this._wikiStatus);
			removeChildren(this._wikiEditor);
			this._wikiEditor.appendChild(document.createTextNode(wikiSource));
			this._wikiEditor.rows= Math.min(120, Math.max(20, wikiSource.split("\n").length * 1.2)); //$NON-NLS-1$
			this._isEditable= true;
			
		} else {
			UI.include(this._wikiStatus);
			this._wikiStatus.appendChild(document.createTextNode(MSGS.ATTACHED_PAGE_NOT_EDITABLE));
			this._isEditable= false;
		}
		this._toolBar.update();
		
		// TODO we should be more careful about what we insert here!
		this._wikiView.innerHTML= pageContent;
	},
	
	_onTextChange: function(evt){
		this._isDirty= true;
		this._toolBar.update();
	},
	
	__sentinel: null // terminates this class definition
});

/**
 * This helper method creates the arguments object for the widget's constructor.
 * @return {Object} a widget private object to be passed in as a constructor argument
 */
com.ibm.team.apt.web.ui.internal.view.plan.TabAttachedPage.constructorArgs= function(iterationPlanPage, attachedPageStub, attachedPageData, serviceCallController) {
	var result= {
		_pageId: attachedPageStub.itemId,
		_planId: iterationPlanPage.getPlanId()
	};
	
	if (attachedPageData != null) {
		result._pageContent= attachedPageData.pageContent;
	}


	var tabId= attachedPageStub.itemId;
	var tabLabel= attachedPageStub.label;
	if (tabId != "overview") { //$NON-NLS-1$
		if (!tabId.match(/[\w\$\.\+\!\*\'\(\)-,]*/)) {
			tabId= encodeURI(tabId);
		}
		tabId= "wikiPage_" + tabId; //$NON-NLS-1$
	} else {
		tabLabel= MSGS.ATTACHEDPAGE_TAB_OVERVIEW;
	}
	return dojo.mixin(result, Tab.constructorArgs(iterationPlanPage, tabId, tabLabel, serviceCallController));
};

})();
