
/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2009. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.apt.web.ui.internal.view.plan.TabPlannedItems"); //$NON-NLS-1$

dojo.require("dijit.form.TextBox"); //$NON-NLS-1$

dojo.require("com.ibm.team.apt.web.ui.internal.EventTopics"); //$NON-NLS-1$

dojo.require("com.ibm.team.apt.web.ui.internal.common.UI"); //$NON-NLS-1$

dojo.require("com.ibm.team.apt.web.ui.internal.view.widgets.SimpleTabContainer"); //$NON-NLS-1$
dojo.require("com.ibm.team.apt.web.ui.internal.view.plan.Tab"); //$NON-NLS-1$

dojo.require("com.ibm.team.apt.web.ui.internal.common.ReferencedItemStore"); //$NON-NLS-1$
dojo.require("com.ibm.team.apt.web.ui.internal.view.common.ViewModelViewer"); //$NON-NLS-1$
dojo.require("com.ibm.team.apt.web.ui.internal.view.common.ViewModelViewerItem"); //$NON-NLS-1$
dojo.require("com.ibm.team.apt.web.ui.internal.view.plan.config.ColorizeConfiguration"); //$NON-NLS-1$
dojo.require("com.ibm.team.apt.web.ui.internal.view.plan.planneditems.Columns"); //$NON-NLS-1$
dojo.require("com.ibm.team.apt.web.ui.internal.view.plan.planneditems.PlanItemViewerItem"); //$NON-NLS-1$
dojo.require("com.ibm.team.apt.web.ui.internal.view.plan.planneditems.OutOfOfficeItemViewerItem"); //$NON-NLS-1$
dojo.require("com.ibm.team.apt.web.ui.internal.view.plan.planneditems.GroupElementViewerItem"); //$NON-NLS-1$
dojo.require("com.ibm.team.apt.web.ui.internal.view.plan.planneditems.OwnerElementViewerItem"); //$NON-NLS-1$
dojo.require("com.ibm.team.apt.web.ui.internal.view.plan.planneditems.RowElementViewerItem"); //$NON-NLS-1$
dojo.require("com.ibm.team.apt.web.ui.internal.view.plan.planneditems.ColumnElementViewerItem"); //$NON-NLS-1$
dojo.require("com.ibm.team.apt.web.ui.internal.view.plan.planneditems.TimeElementViewerItem"); //$NON-NLS-1$
dojo.require("com.ibm.team.apt.web.ui.internal.view.plan.planneditems.MessageElementViewerItem"); //$NON-NLS-1$
dojo.require("com.ibm.team.apt.web.ui.internal.view.plan.actions.ItemMovePolicy"); //$NON-NLS-1$

dojo.require("com.ibm.team.apt.web.ui.internal.view.plan.actions.ToolBarManager"); //$NON-NLS-1$
dojo.require("com.ibm.team.apt.web.ui.internal.view.plan.actions.Separator"); //$NON-NLS-1$
dojo.require("com.ibm.team.apt.web.ui.internal.view.plan.actions.EditPlanModeAction"); //$NON-NLS-1$
dojo.require("com.ibm.team.apt.web.ui.internal.view.plan.actions.CopyPlanModeAction"); //$NON-NLS-1$
dojo.require("com.ibm.team.apt.web.ui.internal.view.plan.actions.DeletePlanModeAction"); //$NON-NLS-1$
dojo.require("com.ibm.team.apt.web.ui.internal.view.plan.actions.SavePlanModeAction"); //$NON-NLS-1$
dojo.require("com.ibm.team.apt.web.ui.internal.view.plan.actions.CancelPlanModeAction"); //$NON-NLS-1$
dojo.require("com.ibm.team.apt.web.ui.internal.view.plan.actions.QuickFilterAction"); //$NON-NLS-1$

dojo.require("com.ibm.team.apt.web.ui.internal.view.plan.actions.DemoteAction"); //$NON-NLS-1$
dojo.require("com.ibm.team.apt.web.ui.internal.view.plan.actions.PromoteAction"); //$NON-NLS-1$
dojo.require("com.ibm.team.apt.web.ui.internal.view.plan.actions.NewWorkItemMenuAction"); //$NON-NLS-1$

dojo.require("dojo.string"); //$NON-NLS-1$
dojo.require("dojo.i18n"); //$NON-NLS-1$
dojo.requireLocalization("com.ibm.team.apt.web.ui.internal", "IterationPlanMessages"); //$NON-NLS-1$ //$NON-NLS-2$

(function() {

var EventTopics						= com.ibm.team.apt.web.ui.internal.EventTopics;

var PlanningClient					= com.ibm.team.apt.web.client.internal.PlanningClient;
var PlanningUtil					= com.ibm.team.apt.web.client.util;

var ReferencedItemStore				= com.ibm.team.apt.web.ui.internal.common.ReferencedItemStore;

var UI								= com.ibm.team.apt.web.ui.internal.common.UI;
var Tab								= com.ibm.team.apt.web.ui.internal.view.plan.Tab;
var ViewModelViewer					= com.ibm.team.apt.web.ui.internal.view.common.ViewModelViewer;
var ResponseHandler					= com.ibm.team.apt.web.client.internal.ProgressMonitoredServiceResponseHandler;

//var PlanModel						= com.ibm.team.apt.client.PlanModel;
//var ViewModel						= com.ibm.team.apt.ui.model.ViewModel;


var ColorizeConfiguration			= com.ibm.team.apt.web.ui.internal.view.plan.config.ColorizeConfiguration;

var ViewModelViewerItem				= com.ibm.team.apt.web.ui.internal.view.common.ViewModelViewerItem;
var PlanItemViewerItem				= com.ibm.team.apt.web.ui.internal.view.plan.planneditems.PlanItemViewerItem;
var OutOfOfficeItemViewerItem		= com.ibm.team.apt.web.ui.internal.view.plan.planneditems.OutOfOfficeItemViewerItem;
var GroupElementViewerItem			= com.ibm.team.apt.web.ui.internal.view.plan.planneditems.GroupElementViewerItem;
var OwnerElementViewerItem			= com.ibm.team.apt.web.ui.internal.view.plan.planneditems.OwnerElementViewerItem;
var RowElementViewerItem			= com.ibm.team.apt.web.ui.internal.view.plan.planneditems.RowElementViewerItem;
var ColumnElementViewerItem			= com.ibm.team.apt.web.ui.internal.view.plan.planneditems.ColumnElementViewerItem;
var TimeElementViewerItem			= com.ibm.team.apt.web.ui.internal.view.plan.planneditems.TimeElementViewerItem;
var MessageElementViewerItem		= com.ibm.team.apt.web.ui.internal.view.plan.planneditems.MessageElementViewerItem;

var ToolBarManager					= com.ibm.team.apt.web.ui.internal.view.plan.actions.ToolBarManager;
var Separator						= com.ibm.team.apt.web.ui.internal.view.plan.actions.Separator;
var SavePlanModeAction				= com.ibm.team.apt.web.ui.internal.view.plan.actions.SavePlanModeAction;
var CancelPlanModeAction			= com.ibm.team.apt.web.ui.internal.view.plan.actions.CancelPlanModeAction;
var DeletePlanModeAction			= com.ibm.team.apt.web.ui.internal.view.plan.actions.DeletePlanModeAction;
var EditPlanModeAction				= com.ibm.team.apt.web.ui.internal.view.plan.actions.EditPlanModeAction;
var CopyPlanModeAction				= com.ibm.team.apt.web.ui.internal.view.plan.actions.CopyPlanModeAction;
var QuickFilterAction				= com.ibm.team.apt.web.ui.internal.view.plan.actions.QuickFilterAction;

var NewWorkItemMenuAction			= com.ibm.team.apt.web.ui.internal.view.plan.actions.NewWorkItemMenuAction;


var Columns							= com.ibm.team.apt.web.ui.internal.view.plan.planneditems.Columns;

var TAB_IDS= {
	BASICS: "basics", //$NON-NLS-1$
	COLUMNS: "columns", //$NON-NLS-1$
	COLORIZE: "colorize" //$NON-NLS-1$
};

var removeChildren= dojox.data.dom.removeChildren;
var bind= dojo.string.substitute;
var MSGS= dojo.i18n.getLocalization("com.ibm.team.apt.web.ui.internal", "IterationPlanMessages"); //$NON-NLS-1$ //$NON-NLS-2$

dojo.declare("com.ibm.team.apt.web.ui.internal.view.plan.TabPlannedItems", //$NON-NLS-1$
			 [com.ibm.team.apt.web.ui.internal.view.plan.Tab, dijit._Templated], {

	// ---- constructor mixed-in properties --------------------------------------------------------------------------------	
	
	_planId: null,
	_plan: null,
	_context: null,
	_referencedItems: null,
	_planPage: null,
	_configurationElements: null,
	
	_viewModel: null,
	_itemMovePolicy: null,
		
	_viewModeList: null,
	_groupingList: null,
	_sortingList: null,
	_filterList: null,
	_barList: null,
	_filterListNode: null,
	_plannedItemsTable: null,
		
	_planModeColumns: null,
	_columnsAvailable: null,
	_columnsSelected: null,
	
	_planModeColorize: null,
	_planModeColorizeContent: null,
	_colorizeConfigWidget: null,
		
	_planModeLabel: null,
	_planModeSelection: null,
	_planModeSelectionList: null,
	_planModeSelectionInput: null,
	_planModeCommands: null,
	_planModePart: null,
	_newAction: null,
	_editAction: null,
	_deleteAction: null,
	_saveAction: null,
	_cancelAction: null,
	
	__planModePartNeverShown: true,
	
	_quickQueryDefinition: null,
	_quickQueryParser: null,

	_messages: MSGS,

	_colorizeTopicHandle: null,

	constructor: function() {
		this._notYetShown= true;
		this._plannedItemsWidget= null;
		this._currentViewOptions= null;
		this._planModeId= null;
		this._filterInstances= {};
		this._colorizerInstances= [];
	},

	// ---- api ------------------------------------------------------------------------------------------------------------	

	setViewOptions: function(viewOptions) {
		this._currentViewOptions= viewOptions;

		if (this._plan) {
			this._applyOptions(viewOptions.viewMode ? this.__getPlanMode(viewOptions.viewMode) : this.getPlanMode()); //$NON-NLS-1$
		}
	},
	
	getViewOptions: function() {
		return this._currentViewOptions;
	},
	
	getTeamMembers: function() {
		return [];
	},
	
	getMyFolders: function() {
	},

	getWorkLoad: function(contributor) {
	},
	
	getBarMode: function() {
	},
	
	showErrorMessage: function(title, description) {
		this._planPage.showErrorMessage(title, description);
	},
	
	getItemMovePolicy: function() {
		return this._itemMovePolicy;
	},
	
	refresh: function() {
		var args= dojo.mixin(this._planPage.getViewOptions(), {id: this._planPage.getPlanId()});
		this._serviceCallController.refreshPlan(args);
	},
	
	// --- plan mode api ---------------------------------------------------------------------------------------------------
	
	getConfigurationElements: function() {
		return this._configurationElements;
	},
	
	getPlanMode: function() {
		return this.__getPlanMode(this._planModeId);
	},
	
	isPlanModeEdit: function() {
		return !dojo.hasClass(this._planModePart, "exclude"); // $NON-NLS-1$
	},
	
	// ---- widget implementation ------------------------------------------------------------------------------------------

	templatePath: dojo.moduleUrl("com.ibm.team.apt.web", "ui/internal/view/plan/templates/TabPlannedItems.html"), //$NON-NLS-1$ //$NON-NLS-2$
	
	widgetsInTemplate: true,
	
	postCreate: function() {
		this._colorizeConfigWidget= new ColorizeConfiguration(ColorizeConfiguration.constructorArgs(), this._planModeColorizeContent);
		this._colorizeTopicHandle= dojo.subscribe(EventTopics.PLAN_PLANMODE_COLORIZE, this, function(colorizeWidget) {
			if (colorizeWidget == this._colorizeConfigWidget) {
				this.__refreshColorize(colorizeWidget.getColorizeConfigs());
			}
		});
		
		
		PlanningUtil.runWithCondition(dojo.hitch(this, function() {
			var constructorArgs= ViewModelViewer.constructorArgs(this, dojo.hitch(this, function(entry, parentItem, viewer) {
				if (entry.isRootEntry()) {
					return new ViewModelViewerItem(entry, null, this, viewer);
				}
				
				var element= entry.getElement();
				if (element instanceof com.ibm.team.apt.client.PlanItem) {
					return new PlanItemViewerItem(entry, parentItem, this, viewer);
				} else if (element instanceof com.ibm.team.apt.client.OutOfOfficeItem) {
					return new OutOfOfficeItemViewerItem(entry, parentItem, this, viewer);
				} else if (element instanceof com.ibm.team.apt.ui.structure.GenericElement) {
					return new GroupElementViewerItem(entry, parentItem, this, viewer);
				} else if (element instanceof com.ibm.team.apt.ui.structure.OwnerElement) {
					return new OwnerElementViewerItem(entry, parentItem, this, viewer);
				} else if (element instanceof com.ibm.team.apt.ui.structure.RowElement) {
					return new RowElementViewerItem(entry, parentItem, this, viewer);
				} else if (element instanceof com.ibm.team.apt.ui.structure.ColumnElement) {
					return new ColumnElementViewerItem(entry, parentItem, this, viewer);
				} else if (element instanceof com.ibm.team.apt.ui.structure.TimeElement) {
					return new TimeElementViewerItem(entry, parentItem, this, viewer);
				} else if (element instanceof com.ibm.team.apt.ui.structure.MessageElement) {
					return new MessageElementViewerItem(entry, parentItem, this, viewer);
				}
				throw new Error("Unsupported view element"); //$NON-NLS-1$ 
			}));
			this._plannedItemsWidget= new ViewModelViewer(constructorArgs, this._plannedItemsTable);

			this._viewModel= new com.ibm.team.apt.ui.model.ViewModel();
			this._itemMovePolicy= new com.ibm.team.apt.web.ui.internal.view.plan.actions.ItemMovePolicy(this._viewModel, dojo.hitch(this, this.getPlanMode));
			
			this._viewModel.setViewer(this._plannedItemsWidget);
			
//			this._actionBar.appendChild(new PlanToolBar(PlanToolBar.constructorArgs(this, this._viewModel, this._plannedItemsWidget)).domNode);
			
			this._toolBar= new ToolBarManager();
			this._toolBar.add(new EditPlanModeAction(this));
			this._toolBar.add(new CopyPlanModeAction(this));
			this._toolBar.add(new DeletePlanModeAction(this));
			this._toolBar.add(new Separator());
			this._toolBar.add(new QuickFilterAction(this));
			this._toolBar.add(new Separator());
			this._toolBar.add(new NewWorkItemMenuAction(this._viewModel, this.getItemMovePolicy(), null, null, this));
			this._toolBar.create(this._planModeCommands); //$NON-NLS-1$
			
			this._viewModel.getSelectionProvider().addSelectionChangedListener(dojo.hitch(this, function() {
				this._toolBar.update();
			}));
			
			var planModeToolBar= new ToolBarManager();
			planModeToolBar.add(new SavePlanModeAction(this));
			planModeToolBar.add(new CancelPlanModeAction(this));
			planModeToolBar.create(this._nodePlanModeToolbar); //$NON-NLS-1$		
			
		}), PlanningClient.getScriptsLoadedCondition());
	},


	destroy: function() {
		if (this._colorizeTopicHandle) {
			dojo.unsubscribe(this._colorizeTopicHandle);
		}
		
		if (this._plannedItemsWidget != null) {
			this._plannedItemsWidget.destroy();
			this._plannedItemsWidget= null;
		}
		
		if (this._plan != null) {
			this._plan.dispose();
//			this._plan= null;
		}
		

		this.inherited(arguments);
	},

	// ---- Tab.js implementation ------------------------------------------------------------------------------------------

	widgetAboutToShow: function() {
		if (this._notYetShown) {
			if (this._plan == null) {
				var serviceCallController= this._getServiceCallController(); 
				
				var _self= this;
				var serviceCallback= {
					_success: function(result) {
						// we have to wait until the scripts are loaded and this widget initialized before we can continue
						PlanningUtil.runWithCondition(function() {
							var loadExecutionItems= _self._iterationPlanPage.getPlanRecord().alwaysLoadAllExecutionItems;
							_self._plan= new com.ibm.team.apt.client.PlanModel(result, _self._planId, loadExecutionItems);
							_self._referencedItems= result._referencedItemStore;
							_self._synchronizeWithWorkingCopies();
							_self._displayPlannedItems();
						}, function() { return _self._viewModel; });
					},
					_error: function(error) {
						serviceCallController.remoteError(error);
					}
				};
				
				var responseHandler= new ResponseHandler(serviceCallback, "_success", "_error"); //$NON-NLS-1$ //$NON-NLS-2$
				responseHandler.setLabel(MSGS.MONITOR_LOAD_PLANNEDITEMS, serviceCallController);		
				PlanningClient.fetchPlannedWorkItems(responseHandler, this._planId);

			} else {
				this._synchronizeWithWorkingCopies();
				this._displayPlannedItems();
			}

			this._notYetShown= false;
		} else {		
			this._synchronizeWithWorkingCopies();
		}
	},
	
	// ---- implementation -------------------------------------------------------------------------------------------------
	
	_synchronizeWithWorkingCopies: function() {
		if (this._plan) {
			this._plan.synchronizeWithWorkItemWorkingCopies();
		}
	},
	
	_onPlanModeSelection: function(evt){
		this.__hidePlanModePart();
		
		var selected= evt.target.options[evt.target.selectedIndex];

		this._currentViewOptions[selected.getAttribute("name")]= selected.getAttribute("value"); //$NON-NLS-1$ //$NON-NLS-2$
		window.location.href= PlanningUtil.getPlanViewURI(this._planId, this._currentViewOptions);

	},
	
	_onNewButton: function(evt) {
		
		var newPlanMode= this.__dupPlanMode(this._planModeId, "__draft_plan_mode"); //$NON-NLS-1$
		newPlanMode.name= bind(MSGS.PLANNEDITEMS_PLAN_MODE_NAME_NEW, [newPlanMode.name]);
		newPlanMode.sharedPlanModeId= null;
		this.__addPlanMode(newPlanMode);
		this.__doShowPlanModePart(newPlanMode);
		this._applyOptions(newPlanMode);
	},
	
	_onEditButton: function(evt) {
		if(this.__isDisabled(evt))
			return;

		var editPlanMode= this.__dupPlanMode(this._planModeId, "__edit_plan_mode"); //$NON-NLS-1$
		this.__addPlanMode(editPlanMode);
		this.__doShowPlanModePart(editPlanMode);
		this._applyOptions(editPlanMode);
	},
	
	_onCancelButton: function(evt){

		this.__hidePlanModePart();
		var planMode=this.__getPlanMode(this._planModeId);
		if(planMode.__orgId){ // dispose draft - show origin
			this.__removePlanMode(planMode);
			planMode= this.__getPlanMode(planMode.__orgId);
		}
		this._applyOptions(planMode);
	},
	
	_onDeleteButton: function(evt){
		if(this.__isDisabled(evt))
			return;
		
		var option= this._planModeSelectionList.options[this._planModeSelectionList.selectedIndex];
		
		var planMode= this.__getPlanMode(option.value);
		var msg= planMode.__hides ? bind(MSGS.PLANNEDITEMS_PLAN_MODE_CONFIRM_DELETE_HIDES, [planMode.name]) : bind(MSGS.PLANNEDITEMS_PLAN_MODE_CONFIRM_DELETE, [planMode.name]);
		if(!confirm(msg))
			return;
		
		var serviceCallController= this._getServiceCallController(); 
		var _self= this;
		var serviceCallback= {
			_success: function(result) {
				var parentNode= option.parentNode;
				parentNode.removeChild(option);
				_self.__removePlanMode(planMode);
				
				var nextPlanMode= _self.__getActivePlanModes()[0];
				if(planMode.__hides){
					// deleted plan mode was hiding another one which is revealed now
					nextPlanMode= _self.__getPlanMode(option.value);
					var fnLabel= function(element){ return element.name; };
					var fnValue= function(element){ return element.id; };
					UI.populateSelect(parentNode, [nextPlanMode], fnLabel, fnValue, null, {name: "viewMode"}); //$NON-NLS-1$
				}
				_self._currentViewOptions["viewMode"]= nextPlanMode.id; //$NON-NLS-1$
				_self._currentViewOptions["ts"]= new Date().getTime(); //$NON-NLS-1$
				window.location.href= PlanningUtil.getPlanViewURI(_self._planId, _self._currentViewOptions);
			},
			_error: function(error) {
				serviceCallController.remoteError(error);
			}
		};
		var responseHandler= new ResponseHandler(serviceCallback, "_success", "_error"); //$NON-NLS-1$ //$NON-NLS-2$
		responseHandler.setLabel(MSGS.PLANNEDITEMS_PLAN_MODE_DELETE, serviceCallController);	
		PlanningClient.deletePlanMode(responseHandler, this.__getPlanMode(option.value).sharedPlanModeId);
	},
	
	_onSaveButton: function(evt) {
		evt.stopPropagation();
		if(this.__isDisabled(evt))
			return;
		
		var planMode= this.__getPlanMode(this._planModeId);
		if(planMode.id == "__edit_plan_mode") //$NON-NLS-1$
			planMode.id= planMode.__orgId;
		
		planMode.colors= this._colorizeConfigWidget.getColorizeConfigs();
		
		var option;
		dojo.query("option", this._planModeSelectionList).forEach(function(element){ //$NON-NLS-1$
			if(element.value == planMode.id)
				option= element;
		});
		
		var serviceCallController= this._getServiceCallController(); 
		var _self= this;
		var serviceCallback= {
			_success: function(result) {
				planMode= _self.__replacePlanMode(result, planMode.id);
				
				if(option){
					option.text= planMode.name;
					option.value= planMode.id;
				} else {
					option= document.createElement("option"); //$NON-NLS-1$
					option.setAttribute("value", planMode.id); //$NON-NLS-1$ //$NON-NLS-2$
					option.setAttribute("name", "viewMode"); //$NON-NLS-1$ //$NON-NLS-2$
					option.setAttribute("selected", true); //$NON-NLS-1$
					option.appendChild(document.createTextNode(planMode.name));
					_self._planModeSelectionList.appendChild(option);
				}
				_self.__hidePlanModePart();
				_self._currentViewOptions["viewMode"]= planMode.id; //$NON-NLS-1$
				_self._currentViewOptions["ts"]= new Date().getTime(); //$NON-NLS-1$
				window.location.href= PlanningUtil.getPlanViewURI(_self._planId, _self._currentViewOptions);
			},
			_error: function(error) {
				serviceCallController.remoteError(error);
			}
		};
		var responseHandler= new ResponseHandler(serviceCallback, "_success", "_error"); //$NON-NLS-1$ //$NON-NLS-2$
		responseHandler.setLabel(MSGS.PLANNEDITEMS_PLAN_MODE_SAVE, serviceCallController);	
		PlanningClient.savePlanMode(responseHandler, this._planId, planMode);
	},
	
	_doPlanModeChange: function(evt){
		evt.stopPropagation();

		var data= new Array();
		var filters= false;
		var elements;
		
		if(evt.target.name == "name"){ //$NON-NLS-1$
			data.push(evt.target.value);
		} else if(evt.target.name == "viewMode"){ //$NON-NLS-1$
			elements= this._configurationElements.styles;
		} else if(evt.target.name == "groupProvider"){ //$NON-NLS-1$
			elements= this._configurationElements.groupings;
			
			var isOwnerGroupMode= function(element) {
				return "com.ibm.team.apt.groupmode.owner" == element.value || "com.ibm.team.apt.groupmode.plannedTime" == element.value; //$NON-NLS-1$ //$NON-NLS-2$
			}
			var disable= !isOwnerGroupMode(evt.target);
			
			dojo.query("input", this._barList).forEach(function(element) { //$NON-NLS-1$
				element.disabled= disable;
				if(disable && "PROGRESS" == element.value) { //$NON-NLS-1$
					element.checked= "checked"; //$NON-NLS-1$
				}
			}, this);
		
			
		} else if(evt.target.name == "sortMode"){ //$NON-NLS-1$
			elements= this._configurationElements.sortings;
		} else if(evt.target.name == "filters"){ //$NON-NLS-1$
			elements= this._configurationElements.filters;
			filters= true;
		} else if(evt.target.name == "barMode"){ //$NON-NLS-1$
			elements= this._configurationElements.bars;
		}
		
		var checkedElements= new Array();
		if(filters){
			dojo.query("input", this._filterList).forEach(function(element){ //$NON-NLS-1$
				if(element.checked)
					checkedElements.push(element.value);
			});
		} else {
			checkedElements.push(evt.target.value);
		}
		
		for(element in elements){
			if(dojo.indexOf(checkedElements, elements[element].id) >= 0){
				data.push(elements[element]);
				if(!filters)
					break;
			}
		}
		
		var update= {};
		update[evt.target.name]= filters ? data : data[0];
		var planMode= this.__updatePlanMode(this.__getPlanMode(this._planModeId), update);
		this._applyOptions(planMode);
		
		// fix for 83210 - it seems that the radio-btn selection state needs 
		// to be managed manually in IE7		
		if(!filters && dojo.isIE < 8){
			dojo.query("input", evt.target.parentNode.parentNode).forEach(function(element) { //$NON-NLS-1$
				if(element === evt.target){
					evt.target.checked= "checked"; //$NON-NLS-1$
				} else if(element.checked){
					element.checked= null; 
				}
			});
		}
	},
	
	__doShowPlanModePart: function(planMode){
		if(this._configurationElements){
			this.__showPlanModePart(this._configurationElements, planMode);
		} else {
			var self= this;
			this.loadConfigurationElements(function(){ 
				self.__showPlanModePart(self._configurationElements, planMode);
			});
		}
		
	},
	
	loadConfigurationElements: function(fnSuccess) {
		var serviceCallController= this._serviceCallController; 
		var self= this;
		var serviceCallback= {
			_success: function(result) {
				self._configurationElements= result; 
				if(dojo.isFunction(fnSuccess)) {
					fnSuccess();
				}
			},
			_error: function(error) {
				serviceCallController.remoteError(error);
			}
		};
		var responseHandler= new ResponseHandler(serviceCallback, "_success", "_error"); //$NON-NLS-1$ //$NON-NLS-2$
		responseHandler.setLabel(MSGS.PLANNEDITEMS_PLAN_MODE_LOAD_CONFIG, serviceCallController);
		PlanningClient.fetchConfigurationElements(responseHandler, this.__getPlan().getPlanId());
	},
	
	__showPlanModePart: function(configurationElements, planMode) {
		
		// tab - basic			
		var parents= [this._viewModeList, this._groupingList, this._sortingList, this._filterList, this._barList];
		dojo.forEach(parents, function(parent){
			dojo.query("div[class=\"entry\"]", parent).forEach(function(element){ //$NON-NLS-1$ //$NON-NLS-2$
				element.parentNode.removeChild(element);
			});
		});
		
		this._planModeSelectionInput.setAttribute("value", planMode.name); //$NON-NLS-1$
		this._planModeSelectionInput.value= planMode.name;
		
		this.__createSelectionList(configurationElements.styles, "viewMode", "radio", this._viewModeList); //$NON-NLS-1$ //$NON-NLS-2$
		this.__createSelectionList(configurationElements.groupings, "groupProvider", "radio", this._groupingList); //$NON-NLS-1$ //$NON-NLS-2$
		this.__createSelectionList(configurationElements.sortings, "sortMode", "radio", this._sortingList); //$NON-NLS-1$ //$NON-NLS-2$
		this.__createSelectionList(configurationElements.filters, "filters", "checkbox", this._filterList); //$NON-NLS-1$ //$NON-NLS-2$
		this.__createSelectionList(configurationElements.bars, "barMode", "radio", this._barList); //$NON-NLS-1$ //$NON-NLS-2$
		dojo.query("input", this._planModeBasics).forEach(function(node) { //$NON-NLS-1$
			this.connect(node, "onclick", "_doPlanModeChange"); //$NON-NLS-1$ //$NON-NLS-2$
		}, this);
			
		if(this.__planModePartNeverShown){
			// initialize tabs
			this._planModeTabs.addTab(TAB_IDS.BASICS, MSGS.PLAN_MODE_BASIC, dojo.hitch(this, function(){ return this._planModeBasics; }));
			this._planModeTabs.addTab(TAB_IDS.COLUMNS, MSGS.PLAN_MODE_COLUMNS, dojo.hitch(this, function(){ return this._planModeColumns; }));
			this._planModeTabs.addTab(TAB_IDS.COLORIZE, MSGS.PLAN_MODE_COLORIZE, dojo.hitch(this, function(){ return this._planModeColorize; }));
			this._planModeTabs.selectTab(TAB_IDS.BASICS);
		}
		
		// tab - basic
		this.__updateOptionsSelection("input", planMode.viewMode.id, this._viewModeList); //$NON-NLS-1$
		this.__updateOptionsSelection("input", planMode.groupProvider.id, this._groupingList); //$NON-NLS-1$
		this.__updateOptionsSelection("input", planMode.sortMode.id, this._sortingList); //$NON-NLS-1$
		dojo.forEach(planMode.filters, function(filter){
			this.__updateOptionsSelection("input", filter.id, this._filterList); //$NON-NLS-1$
		}, this);
		this.__updateOptionsSelection("input", planMode.barMode.id, this._barList); //$NON-NLS-1$
		
		// tab - columns
		this._updateSelectedColumns(planMode);

		// tab - colorize
		this._updateColorize(planMode);
		
		// toggle ui		
		this.__exclude([this._planModeSelectionList]);
		this.__include([this._planModePart, this._planModeSelectionInput]);
		dojo.addClass(this._planModeSelection, "planModePartBackground"); //$NON-NLS-1$
		dijit.selectInputText(this._planModeSelectionInput);
		this.__planModePartNeverShown= false;
	},
	
	__hidePlanModePart: function(){
		this.__exclude([this._planModePart, this._planModeSelectionInput]);
		this.__include([this._planModeSelectionList]);
		dojo.removeClass(this._planModeSelection, "planModePartBackground"); //$NON-NLS-1$
	},
	
	_applyOptions: function(planMode) {
		this._viewModel.updateModel(function(updateAccessor){
			var i;
			var optionsStore= planMode.getStore();
			var getPlanFn= dojo.hitch(this, this.__getPlan);
			
			var groupProviderCtor= dojo.getObject(planMode.groupProvider.implementation);
			var groupProvider= new groupProviderCtor(getPlanFn, {
				context: this._context,
				columns: planMode.columns,
				parameters: planMode.groupProvider.parameters
			});
			groupProvider.loadOptions(optionsStore.subStore("groupProvider")); //$NON-NLS-1$
			this._itemMovePolicy.setGroupProvider(groupProvider);
			
			var viewModeCtor= dojo.getObject(planMode.viewMode.implementation);
			var viewMode= new viewModeCtor(getPlanFn, groupProvider, {
				context: this._context,
				columns: planMode.columns,
				parameters: planMode.viewMode.parameters
			});
			viewMode.loadOptions(optionsStore.subStore("viewMode")); //$NON-NLS-1$
			this._itemMovePolicy.setViewMode(viewMode);
			
			this._viewModel.setModelTransformer(viewMode);
			this._planModeId= planMode.id;
			
			var sorterCtor= dojo.getObject(planMode.sortMode.implementation);
			var sorter= new sorterCtor({
				context: this._context,
				columns: planMode.columns,
				parameters: planMode.sortMode.parameters
			});
			sorter.loadOptions(optionsStore.subStore("sortMode")); //$NON-NLS-1$
			sorter.setComparator(viewMode.getEntryComparator());
			this._viewModel.setSorter(sorter);
			this._itemMovePolicy.setEntrySorter(sorter);

			// remove old filters
			for (var filterId in this._filterInstances) {
				this._viewModel.removeFilter(this._filterInstances[filterId]);
				delete this._filterInstances[filterId];
			}

			// add new filters
			for (i= 0; i < planMode.filters.length; i++) {
				var filterCtor= dojo.getObject(planMode.filters[i].implementation);
				var filter= new filterCtor(getPlanFn, {
					context: this._context,
					columns: planMode.columns,
					parameters: planMode.filters[i].parameters
				});
				this._viewModel.addFilter(filter);
				this._filterInstances[planMode.filters[i].id]= filter;
			}
			
			this.__refreshColorize(planMode.colors);

		}, this);
		
		this._updateOptionsLabels();
	},
	
	__refreshColorize: function(colors) {
		this.__updatePlanMode(this.__getPlanMode(this._planModeId), { colors: colors});
		this._viewModel.updateModel(function(updateAccessor){
			dojo.forEach(this._colorizerInstances, function(colorizer) {
				colorizer.setEnabled(false);
			}, this);
			this._colorizerInstances= [];

			for (i= 0; i < colors.length; i++) {
				var colorizer= new com.ibm.team.apt.internal.ui.quickquery.QuickQueryColorizer(this._viewModel);
				colorizer.deferUpdates(function() {
					colorizer.setPriority(colors[i].priority);
					colorizer.setLabel(colors[i].label);
					colorizer.setColor(dojo.colorFromHex(colors[i].color));
					colorizer.setEnabled(colors[i].enabled);
					colorizer.setExpression(this._quickQueryParser.getExpression(colors[i].expression));
					
				}, this);
				this._colorizerInstances.push(colorizer);
			}
		}, this);
	},
	
	_updateOptionsLabels: function() {		
		dojo.query("option", this._planModeSelection).forEach(function(element) { //$NON-NLS-1$
			var isSelected= this._planModeId == element.getAttribute("value"); //$NON-NLS-1$
			element.selected= isSelected;
		}, this);
		
		this._toolBar.update();
	},
	
	_updateSelectedColumns: function(planMode) {
		
		// XXX use PlanItem.ATTR instead
		var hiddenColumns= ["com.ibm.team.apt.attribute.planitem.id", "com.ibm.team.apt.attribute.summary", "com.ibm.team.apt.attribute.planitem.description", "com.ibm.team.apt.attribute.sequenceValue"];//$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$
		
		// select - available columns
		var functionAvailable= {};
		functionAvailable.fnValue= function(element) { return element.id; };
		functionAvailable.fnLabel= function(element) { return element.name; };
		functionAvailable.fnFilter= function(element){ return dojo.indexOf(hiddenColumns, element.id) < 0 && dojo.indexOf(planMode.columns, element.id) < 0; };
		UI.selectClear(this._columnsAvailable);
		UI.selectPopulate(this._columnsAvailable, this._configurationElements.columns, functionAvailable);
		dojo.query("option", this._columnsAvailable).forEach(function(option){ dojo.hitch(this, dojo.connect(option, "ondblclick", dojo.hitch(this, this._onAddOne))) }, this); //$NON-NLS-1$ //$NON-NLS-2$
		
		// select - selected columns
		var functionSelected= {};
		functionSelected.fnValue= function(element) { return element; };
		functionSelected.fnLabel= dojo.hitch(this, function(element){
			var columns= this._configurationElements.columns;
			var ids= dojo.map(columns, function(item) { return item.id; });
			var index= dojo.indexOf(ids, element);
			if(index >= 0){
				return columns[index].name;
			}
		});
		functionSelected.fnCompare= function(e1, e2) { 
			return dojo.indexOf(planMode.columns, e1) - dojo.indexOf(planMode.columns, e2); 
		};
		UI.selectClear(this._columnsSelected);
		UI.selectPopulate(this._columnsSelected, planMode.columns, functionSelected); //$NON-NLS-1$ //$NON-NLS-2$
		dojo.query("option", this._columnsSelected).forEach(function(option){ dojo.hitch(this, dojo.connect(option, "ondblclick", dojo.hitch(this, this._onRemoveOne))) }, this); //$NON-NLS-1$ //$NON-NLS-2$
	},
	
	_updateColorize: function(planMode) {
		this._colorizeConfigWidget.setColorizeConfig(planMode.colors);
	},
	
	// ------------------------------------ column actions ------------------------------------------------------------------
	_onSetDefault: function(){
		this.__updateColumns(["com.ibm.team.apt.attribute.planitem.priority"]); // $NON-NLS-1$
	},
	
	_onAddAll: function(){
		var columns= UI.selectGetAll(this._columnsAvailable).concat(UI.selectGetAll(this._columnsSelected))
		this.__updateColumns(columns);
	},
	
	_onAddOne: function(){
		var columns= UI.selectGetAll(this._columnsSelected).concat(UI.selectGetSelection(this._columnsAvailable));
		this.__updateColumns(columns);
	},
	
	_onRemoveAll: function(){
		this.__updateColumns();
	},
	
	_onRemoveOne: function(){
		var result= [];
		var columns= UI.selectGetSelection(this._columnsSelected);
		var allColumns= UI.selectGetAll(this._columnsSelected);
		dojo.forEach(allColumns, function(column) {
			if(dojo.indexOf(columns, column) < 0)
				result.push(column);
		});
		this.__updateColumns(result);
	},
	
	_onUp: function(){
		var column= UI.selectGetSelection(this._columnsSelected);
		if(column.length == 0)
			return;
		column= column[0];
		var allColumns= UI.selectGetAll(this._columnsSelected);
		var index= dojo.indexOf(allColumns, column);
		if(index > 0){
			allColumns.splice(index, 1);
			allColumns.splice(index - 1, 0, column);
		}
		this.__updateColumns(allColumns);
	},
	
	_onDown: function(){
		var column= UI.selectGetSelection(this._columnsSelected);
		if(column.length == 0)
			return;
		column= column[0];
		var allColumns= UI.selectGetAll(this._columnsSelected);
		var index= dojo.indexOf(allColumns, column);
		if(index < allColumns.length - 1){
			allColumns.splice(index, 1);
			allColumns.splice(index + 1, 0, column);
		}
		this.__updateColumns(allColumns);
	},
	
	__updateColumns: function(columns){
		var update= {};
		update.columns= columns || [];
		var planMode= this.__updatePlanMode(this.__getPlanMode(this._planModeId), update);
		this._applyOptions(planMode);
		this._updateSelectedColumns(planMode);
	},
	
	_getItem: function(type, id) {
		return this._referencedItems.getItem(type, id);
	},

	_displayPlannedItems: function() {
		var planModes= this._plan.getPlanModes();

		this._context= this.__createContext();
		this._quickQueryDefinition= new com.ibm.team.apt.internal.ui.quickquery.QuickQueryDefinition(dojo.hitch(this, function() { return this._plan; }) );
		this._quickQueryParser= new com.ibm.team.apt.internal.ui.quickquery.QuickQueryParser(this._quickQueryDefinition);
		
		UI.include(this._planModeLabel);
		
		this._planModeSelectionList= this.__createPlanModeSelection(this.__getActivePlanModes(), "viewMode", this._planModeSelection); //$NON-NLS-1$
		this.connect(this._planModeSelectionList, "onchange", "_onPlanModeSelection"); //$NON-NLS-1$ //$NON-NLS-2$
		
		this._planModeSelectionInput= document.createElement("input"); //$NON-NLS-1$
		dojo.addClass(this._planModeSelectionInput, "planModeSelectionInput"); //$NON-NLS-1$
		this.__exclude(this._planModeSelectionInput);
		this._planModeSelectionInput.setAttribute("type", "text"); //$NON-NLS-1$ //$NON-NLS-2$
		this._planModeSelectionInput.setAttribute("name", "name");  //$NON-NLS-1$ //$NON-NLS-2$
		this._planModeSelection.appendChild(this._planModeSelectionInput);
		this.connect(this._planModeSelectionInput, "onchange", "_doPlanModeChange") //$NON-NLS-1$ //$NON-NLS-2$
		
		this._viewModel.setInput(this._plan);
		if (this._currentViewOptions) {
			this.setViewOptions(this._currentViewOptions);
		}
		
		var planPage= this._planPage;
		
		var deltaVisitor= function(delta) {
			var planItem= delta.getPlanElement();
			if(!(planItem instanceof com.ibm.team.apt.client.PlanItem))
				return true; 
				
			var modify= function(add, receiver, delta){
				receiver.deltaOpenCount(delta.getOpenCount() * (add ? 1 : -1));
				receiver.deltaCloseCount(delta.getCloseCount() * (add ? 1 : -1));
				receiver.deltaEstimateCount(delta.getEstimatedCount() * (add ? 1 : -1));
				receiver.deltaStepsDone(delta.getStepsDone() * (add ? 1 : -1));
				receiver.deltaStepsLeft(delta.getStepsLeft() * (add ? 1 : -1));
			};
			
			var planProgress= planItem.getPlanModel().getPlanProgress();	
			var computerCtor= dojo.getObject(planProgress.computerImplementation);
			var complexityAttr= planProgress.complexityAttribute;
			
			var progressInformation= planPage.getProgressInformation();
			
			if((delta.isAdded() || delta.isRemoved()) && !delta.isMoveChange()){
				var newProgressInfo= new com.ibm.team.apt.internal.ui.progress.ProgressInformation();
				var itemAccessor= new com.ibm.team.apt.client.PlanElementAccessor(planItem.getPlanModel().getComplexityAttribute());			
				var newProgressComputer= new computerCtor(itemAccessor, newProgressInfo);
				
				newProgressComputer.compute(planItem.getPlanModel());
				
				modify(false, progressInformation, progressInformation);
				modify(true, progressInformation, newProgressInfo);
				
			} else if(com.ibm.team.apt.client.PlanElementDeltaAccessor.affects(delta)){
				
				var oldStateAccessor= new com.ibm.team.apt.client.PlanElementDeltaAccessor(planItem, false, complexityAttr && complexityAttr.attributeId);
				var newStateAccessor= new com.ibm.team.apt.client.PlanElementDeltaAccessor(planItem, true, complexityAttr && complexityAttr.attributeId);
				var oldStateProgressInfo= new com.ibm.team.apt.internal.ui.progress.ProgressInformation();
				var newStateProgressInfo= new com.ibm.team.apt.internal.ui.progress.ProgressInformation();
				
				var oldStateComputer= new computerCtor(oldStateAccessor, oldStateProgressInfo);
				var newStateComputer= new computerCtor(newStateAccessor, newStateProgressInfo);
				
				newStateComputer.compute(delta);
				oldStateComputer.compute(delta);
				
				modify(false, progressInformation, oldStateProgressInfo);
				modify(true, progressInformation, newStateProgressInfo);
			}
			planPage.updateProgress();
			
			return true; 
		};
		var progressUpdater= function(event) {
			PlanningUtil.runWithCondition(dojo.hitch(this, function() {
				event.getDelta().accept(deltaVisitor);
			}), PlanningClient.getScriptsLoadedCondition());
		};
		this._plan.addListener(progressUpdater);
	},
	
	__createAction: function(label, style, parentNode) {
		var container=document.createElement("a"); //$NON-NLS-1$
		dojo.addClass(container, "command"); //$NON-NLS-1$
		dojo.addClass(container, style);
		container.setAttribute("title", label); //$NON-NLS-1$
		parentNode.appendChild(container);
		return container;
	},
	
	__createPlanModeSelection: function(planModeDescriptors, name, parentNode) {
		var fnLabel= function(element){ return element.name; };
		var fnValue= function(element){ return element.id; };
		var selection= document.createElement("select"); //$NON-NLS-1$
		UI.populateSelect(selection, planModeDescriptors, fnLabel, fnValue, null, {name: name});
		parentNode.appendChild(selection);
		return selection;
	},
	
	__createSelectionList: function(configurationDescriptors, name, type, parentNode){
		var fnLabel= function(element){ return element.name; };
		var fnValue= function(element){ return element.id; };
		UI.populateInput(parentNode, configurationDescriptors, fnLabel, fnValue, null, {name: name, type: type});
	},
	
	__updateOptionsSelection: function(selector, value, node) {	
		
		dojo.query(selector, node).forEach(function(element) { //$NON-NLS-1$
			if(value == element.getAttribute("value")){ //$NON-NLS-1$
				element.checked= "checked"; //$NON-NLS-1$ 
				element.defaultChecked= "checked"; //$NON-NLS-1$
			}
		}, this);
	},
	
	// ---- ui elements helper ---------------------------------------------------------------------------------------------
	
	/*
	 * Use the UI helper
	 */
	
	__isDisabled: function(evt){
		return dojo.hasClass(evt.target, "disabled"); //$NON-NLS-1$
	},
	
	
	__exclude: function(elements){
		this.__forEachAndOne(elements, function(element){
			dojo.addClass(element, "exclude"); //$NON-NLS-1$
		});
	},
	
	__include: function(elements){
		this.__forEachAndOne(elements, function(element){
			dojo.removeClass(element, "exclude"); //$NON-NLS-1$
		});
	},
	
	__forEachAndOne: function(elements, fn){
		if(!dojo.isArray(elements)){
			fn(elements);
		} else {
			dojo.forEach(elements, function(element){
				fn(element);
			});
		}
	},
	
	// ---- update/modify plan modes ---------------------------------------------------------------------------------------
	
	__getActivePlanModes: function(){
		var map= new Array();
		var result= new Array();
		var planModes= this._plan.getPlanModes();
		var compare= function(a, b){
			if(a.sharedPlanModeId && b.sharedPlanModeId){
				return 0;
			} else if(a.sharedPlanModeId){
				return -1;
			} else {
				return +1;
			}
		};
		planModes.sort(compare);
		for (var i= 0; i < planModes.length; i++) {
			var prop = planModes[i].id;
			if(map[prop] == undefined){
				result.push(planModes[i]);
				map[prop]= result.length - 1;
				
			} else {
				var cmp= compare(result[map[prop]], planModes[i]);
				if(cmp == 0){
					var index= map[prop];
					result.splice(index, 1, planModes[i]);
				}
				if(cmp < 0){
					result[map[prop]].__hides= true;
				}
			}
		}
		return result;
	},
	
	__getPlanMode: function(planModeId){
		var planMode= this.__processPlanMode(planModeId, function(index, planModes, isDefault){
			if(!isDefault)
				return planModes[index];
		}, true);
		if(planMode)
			return planMode;
		
		return this.__processPlanMode(this.__getPlan().getDefaultPlanModeId(), function(index, planModes){
			return planModes[index];
		}, true);
	},
	
	__addPlanMode: function(planMode){
		this._plan.getPlanModes().push(planMode);
	},
	
	__removePlanMode: function(planMode){
		this.__processPlanMode(planMode.id, function(index, planModes, isDefault){
			if(isDefault)
				return;
			if(planMode == planModes[index])
				planModes.splice(index, 1);
		});
	},
	
	__replacePlanMode: function(planMode, planModeId){
		if(!planModeId)
			planModeId= planMode.id;
		return this.__processPlanMode(planModeId, function(index, planModes, isDefault){
			if(isDefault)
				return planMode;
			planMode["getStore"]= planModes[index]["getStore"]; //$NON-NLS-1$ //$NON-NLS-2$
			planModes.splice(index, 1, planMode);
			return planMode;
		})
	},
	
	__dupPlanMode: function(planModeId, newPlanModeId){
		return this.__processPlanMode(planModeId, function(index, planModes, isDefault) {
			if(isDefault)
				return null;
			
			var copy= function(configuration){
				return configuration;
//				var result= {};
//				result["id"]= configuration.id; //$NON-NLS-1$
//				result["name"]= configuration.name; //$NON-NLS-1$
//				result["description"]= configuration.description; //$NON-NLS-1$
//				result["implementation"]= configuration.implementation; //$NON-NLS-1$
//				return result;
			};
			
			var planMode= planModes[index];
			var newPlanMode= {};
			newPlanMode["id"]= newPlanModeId; //$NON-NLS-1$
			newPlanMode["__orgId"]= planMode.id; //pointer to origin //$NON-NLS-1$
			newPlanMode["name"]= planMode.name; //$NON-NLS-1$
			newPlanMode["sharedPlanModeId"]= planMode.sharedPlanModeId; //$NON-NLS-1$
//			newPlanMode["getStore"]= new com.ibm.team.apt.ui.model.OptionsStore("({})"); XXX cannot create options store
			newPlanMode["getStore"]= planMode.getStore; //$NON-NLS-1$
			newPlanMode["viewMode"]= copy(planMode.viewMode); //$NON-NLS-1$
			newPlanMode["groupProvider"]= copy(planMode.groupProvider); //$NON-NLS-1$
			newPlanMode["sortMode"]= copy(planMode.sortMode); //$NON-NLS-1$
			newPlanMode["filters"]= new Array(); //$NON-NLS-1$
			dojo.forEach(planMode.filters, function(filter){
				newPlanMode["filters"].push(copy(filter)); //$NON-NLS-1$
			});
			newPlanMode["barMode"]= planMode.barMode; //$NON-NLS-1$
			newPlanMode["colors"]= new Array(); //$NON-NLS-1$
			dojo.forEach(planMode.colors, function(color){
				newPlanMode["colors"].push(copy(color)); //$NON-NLS-1$
			});
			newPlanMode["columns"]= new Array(); //$NON-NLS-1$
			dojo.forEach(planMode.columns, function(column){
				newPlanMode["columns"].push(copy(column)); //$NON-NLS-1$
			});
			return newPlanMode;
		});
	},
	
	__processPlanMode: function(planModeId, fn, activeOnly){
		var planModes= activeOnly ? this.__getActivePlanModes() : this._plan.getPlanModes();
		for (var i= 0; i < planModes.length; i++) {
			if (planModeId == planModes[i].id) {
				return fn(i, planModes, false);
			}
		}
		return fn(planModes[0], planModes, true);
	},
	
	__updatePlanMode: function(planMode, update){
		var property;
		for(property in planMode){
			if(update[property]){
				planMode[property]= update[property];
			}
		}
		return planMode;
	},
	
	__getPlan: function() { 
		return this._plan;
	},
	
	isResolved: function() {
		return this.__getPlan() !== null;
	},
	
	__createContext: function() {
		
//		// use this scope as cache
//		var priorities= this._referencedItems.getItems(ReferencedItemStore.ITEM_TYPES.PRIORITY);
//		var severities= this._referencedItems.getItems(ReferencedItemStore.ITEM_TYPES.SEVERITY);
//		var unassignedContributor= this._plan.getUnassignedContributor();
		
		return new com.ibm.team.foundation.common.Context({
//			"com.ibm.team.workitem.common.PriorityContext": { //$NON-NLS-1$
//				getPriorityValues: function() {
//					return priorities;
//				}
//			},
//			"com.ibm.team.workitem.common.SeverityContext": { //$NON-NLS-1$
//				getSeverityValues: function() {
//					return priorities;
//				}
//			},
//			"com.ibm.team.repository.common.ContributorContext": { //$NON-NLS-1$
//				getUnassignedContributor: function() {
//					return unassignedContributor;
//				}
//			}
		});
	},

	__sentinel: null // terminates this class definition
});

com.ibm.team.apt.web.ui.internal.view.plan.TabPlannedItems.constructorArgs= function(iterationPlanPage, plannedItemsPageData, serviceCallController) {
	var result= {
		_planPage: iterationPlanPage,
		_planId: iterationPlanPage.getPlanId(),
		_teamMemberWorkLoad: {},
		_referencedItems: null
	};
	
	if (plannedItemsPageData != null) {
		result._plan= new com.ibm.team.apt.client.PlanModel(plannedItemsPageData);
		result._referencedItems= plannedItemsPageData._referencedItemStore;
	}

	return dojo.mixin(result, Tab.constructorArgs(iterationPlanPage, "viewModel", MSGS.PLANNEDITEMS_TAB_NAME, serviceCallController)); //$NON-NLS-1$ //$NON-NLS-2$
};

})();
