/*
 * Licensed Materials - Property of IBM
 * Rational ClearQuest 
 * (C) Copyright IBM Corp. 2009  All Rights Reserved
 * US Government Users Restricted Rights -
 * Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp
 */
dojo.provide("com.ibm.rational.cm.web.ui.view.common.MessageDialog");

dojo.require("com.ibm.rational.cm.web.ui.view.common.Dialog");
dojo.require("dijit.form.Button");
dojo.require("com.ibm.rational.cm.web._base");
dojo.requireLocalization("com.ibm.rational.cm.web.ui","common");

(function(){
	
var cq = com.ibm.rational.cm.web;

dojo.declare(
	"com.ibm.rational.cm.web.ui.view.common.MessageDialog",
	com.ibm.rational.cm.web.ui.view.common.Dialog,
{
	iconClass: "",
	title: "",
	message: "",
	description: "",
	
	postMixInProperties:function(){
		this._commonStrings = dojo.i18n.getLocalization("com.ibm.rational.cm.web.ui", "common", this.lang);
		this.inherited(arguments);
	},
	
	postCreate: function(){
		var containerNode = this.containerNode;
		
		// add message node
		var msgNode = this.messageNode = dojo.doc.createElement("DIV");
		msgNode.style.paddingLeft = "10px";
		containerNode.appendChild(msgNode);
		this.setMessage(this.message);
		
		// add collapsible section
		// use load API since somehow CSS module is not loaded by static dojo["require"]
		cq.loadModuleSync("com.ibm.rational.cm.web.ui.view.common.Section");
		var sec = this._section = new com.ibm.rational.cm.web.ui.view.common.Section({ title: this._commonStrings.lblDetails, collapsed: true });
		containerNode.appendChild(sec.domNode);
		var sectStyle = sec.domNode.style;
		sectStyle.paddingTop = "10px";
		sectStyle.paddingBottom = "10px";
		var sectContentStyle = sec.contentNode.style; 
		sectContentStyle.overflow = "auto";		
		if((dojo.isIE && dojo.isIE < 7)){
			sectContentStyle.height = "350px";
		}else{
			sectContentStyle.maxHeight = "350px";
		}
		this.setDescription(this.description);
		
		// add close button
		var btn = dojo.doc.createElement("BUTTON");
		dojo.attr(btn, {
			onclick: dojo.hitch(this, "hide"),
			style: {
				"float": "right",
				marginBottom: "10px"
			},
			innerHTML: this._commonStrings.lblClose
		});
		containerNode.appendChild(btn);

		this.inherited(arguments);
		
		// add icon node
		var iconClass = this.iconClass;
		if(iconClass && iconClass.length > 0){
			var iconNode = dojo.doc.createElement("DIV");
			dojo.addClass(iconNode, "dijitInline");
			dojo.addClass(iconNode, iconClass);
			dojo.place(iconNode, this.titleNode, "before");
		}
	},
	
	show: function(){
		this._section.doCollapse(true);
		this.inherited(arguments);
	},
	
	setMessage: function(msg){
		this.messageNode.innerHTML = com.ibm.rational.cm.web.getAbbreviatedString(msg, 1200); // RATLC01260764 : Error message box does not handle long strings well
	},
	
	setDescription: function(desc){
		this._section.setContent(desc);
		this._section.domNode.style.display = (desc && desc.length > 0) ? "" : "none"; // RATLC01259129 : Error dialog should not show "Details" twisty if there are no details
	}
});

})();