/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2009. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.rational.cm.web.workitem.ui.view.record.TasksPart");

dojo.require("com.ibm.rational.cm.web.ui.view.record.QuickInformationPart");
/* NO_CREATION_DIALOG
dojo.require("com.ibm.rational.cm.web.workitem.ui.view.record.WorkItemPicker");
*/
dojo.require("com.ibm.team.workitem.web.ui.internal.view.editor.SelectWorkItemDialog");
dojo.require("com.ibm.team.workitem.web.ui.internal.module.WorkItemPickerWidget"); // just for loading CSS module for SelectWorkItemContent 
dojo.require("com.ibm.team.workitem.web.client.util");
dojo.require("com.ibm.team.repository.web.transport.ServiceRequest");
dojo.require("com.ibm.team.repository.web.transport.ServiceResponseHandler");
dojo.require("com.ibm.team.repository.web.transport.TeamServerClient");
dojo.require("jazz.client.xhr");
dojo.require("jazz.ui.Dialog");
dojo.require("dijit.form.Button");
dojo.require("dijit.Menu");

dojo.requireLocalization("com.ibm.rational.cm.web.workitem.ui", "TasksPart");
dojo.requireLocalization("com.ibm.rational.cm.web.ui","cqStrings");
/*
 * This is a wrapper widget that shows the Approvals Section
 */
(function(){
	var messages;
	var basemessages;
	var WorkItemUtil = com.ibm.team.workitem.web.client.util;

	// constants
	var SERVICE_PREFIX   = net.jazz.ajax._contextRoot + "/service/";	 //$NON-NLS-1$
	var WORK_ITEM_REST_SERVICE_URI	= "com.ibm.team.workitem.service.internal.roa.IRestService"; //$NON-NLS-1$
	var PROCESS_SERVICE_URI = "com.ibm.team.process.internal.common.service.IProcessRestService";
	var RCM_LINK_SERVICE_URI      = "com.ibm.rational.cm.web.linkmanager.IRCMLinkRestService"; //$NON-NLS-1$
	
	// utility objects
	var ServiceRequest = com.ibm.team.repository.web.transport.ServiceRequest;
	var ServiceResponseHandler = com.ibm.team.repository.web.transport.ServiceResponseHandler;
	var TeamServerClient = com.ibm.team.repository.web.transport.TeamServerClient;
	
	// utility methods
	var getCurrentProjectArea = com.ibm.team.process.web.client.projectarea.getCurrentProjectArea;
	
	var CMRECORD_LINKTYPE = "com.ibm.team.workitem.linktype.relatedChangeManagement";
	var ITEM_KEY_RESULT= "oslc_cm:results";
	var ITEM_KEY_URI= "rdf:resource";
	
    /* defineWidget */
    dojo.declare("com.ibm.rational.cm.web.workitem.ui.view.record.TasksPart", 
				com.ibm.rational.cm.web.ui.view.record.QuickInformationPart,
	{
		title: dojo.i18n.getLocalization("com.ibm.rational.cm.web.workitem.ui", "TasksPart").WorkItems,
    	currentLinkItemIds: [],
		
		constructor: function(){
			messages = dojo.i18n.getLocalization("com.ibm.rational.cm.web.workitem.ui", "TasksPart");
			basemessages = dojo.i18n.getLocalization("com.ibm.rational.cm.web.ui", "cqStrings");
		},

		_createMenu: function(){
			var menu = new dijit.Menu({
			});
			menu.addChild(new dijit.MenuItem({
				label: messages.LinkToWorkItems,
				onClick: dojo.hitch(this, function(){this._openLinksDialog();})
			}));
			var newWorkItemMenu = new dijit.PopupMenuItem({
				label: messages.CreateNewWorkItem,
//				popup:this._buildProjectAreaMenu(menu)
				popup:this._buildWorkItemTypeMenu(menu, getCurrentProjectArea())
			});
			menu.addChild(newWorkItemMenu);
			var link = new dijit.form.DropDownButton({
				label: messages.LinkToWorkItems,
				showLabel: false,
				iconClass: "MenuIcon_associateWorkItem",
				dropDown: menu
			});
			menu.startup();
			this._menu = menu;
//			var link = new dijit.form.Button({
//				label: messages.LinkToWorkItems,
//				showLabel: false,
//				iconClass: "MenuIcon_associateWorkItem",
//				onClick: dojo.hitch(this, function(){this._openLinksDialog();})
//			});
			this._menuNode.addChild(link);
		},
		
		_destroyMenu: function(){
			if(this._menu){
				this._menu.destroyRecursive();
				this._menu = null;
			}
			if(this._popupMenus){
				dojo.forEach(this._popupMenus, function(menu){
					if (menu.domNode) {
						menu.destroyRecursive();
					}
				});
				this._popupMenus = null;
			}
		},
		
		_addPopupMenu: function(menu){
			if(!this._popupMenus) this._popupMenus = [];
			this._popupMenus.push(menu);
		},

		
		getCurrentLinkItemIds: function(){
			return this.currentLinkItemIds;
		},
		
		_openLinksDialog: function() {
/* NO_CREATION_DIALOG
			var self = this;
			var args = {
				onOk: function(selectedWorkItems) {
					self.workItemPickerDialog.close();
					self.addNewLink(selectedWorkItems);
				},
				onCancel: function() {
					self.workItemPickerDialog.close();
				}
			};
			var dialogContent = new com.ibm.rational.cm.web.workitem.ui.view.record.WorkItemPicker(args);
			
			var workItemPickerDialogParams = {
	            primaryTitle: messages.AddWorkItems,
				width: '750px',
				height: '450px',
				contentNode: dialogContent.domNode
			};		
			this.workItemPickerDialog = new jazz.ui.Dialog(workItemPickerDialogParams);
			dialogContent.startup();
*/
			var self = this;
			var args = {
				onOk: function(selectedWorkItems) {
					self.addNewLink(selectedWorkItems);
				},
				exclusionList: {},
				dialogTitle: messages.AddWorkItems
			};	
			var dialog = new com.ibm.team.workitem.web.ui.internal.view.editor.SelectWorkItemDialog(args);
		},
		
		addNewLink: function(workItems) {
			// Add the work items to the type's linkDTOs
			var arry = workItems[ITEM_KEY_RESULT];
			if(arry === undefined && dojo.isArray(workItems)) {
				arry = workItems;
			}
			if(!arry || arry.length == 0){
				return;
			}
			var wis = [];
			for (var i=0; i<arry.length; i++) {
				var uri = arry[i][ITEM_KEY_URI];
				var id = uri ? uri.substring(uri.lastIndexOf("/")+1) : arry[i].id;
				if (id) {
					wis.push(id);
				}
			};
			wis.sort();
			this._addItemToLinks(wis);
		},
		
		_addItemToLinks: function(workitems){
			var args = {
				workItemIds: workitems.join(","),
				recordURL: this._getRecordURL(),
				recordTitle: this.recordTitle
			};
			jazz.client.xhrPost({
				url: SERVICE_PREFIX + RCM_LINK_SERVICE_URI + "/links",
				content: args,
				load: dojo.hitch(this, "handleAddLinks"),
				error: this.handleAddLinksError
			});
		},

		_removeItemFromLinksWithConfirm: function(workitems){
			var confirmMessage = dojo.string.substitute(messages.ConfirmRemove, [workitems]);
			if (confirm(confirmMessage)) 
			{
				this._removeItemFromLinks(workitems);
			}
		},

		_removeItemFromLinks: function(workitems){
			var args = {
				recordURL: this._getRecordURL(),
				recordTitle: this.recordTitle
			};
			if(workitems){
				args.workItemIds = workitems.join(",");
			}
			jazz.client.xhrDelete({
				url: SERVICE_PREFIX + RCM_LINK_SERVICE_URI + "/links",
				content: args,
				load: dojo.hitch(this, function(){this.refresh();}),
				error: dojo.hitch(this, function(){})
			});
		},

		handleAddLinks: function() {
			this.refresh();
		},
		
		handleAddLinksError: function() {
		},
		
		_getLinks: function(){
			if(!this.recordId){
				this.resetWidget(); // clear content
				return;
			}
			var args = {
				recordURL: this._getRecordURL()
			};
			jazz.client.xhrGet({
				url: SERVICE_PREFIX + RCM_LINK_SERVICE_URI + "/links",
				content: args,
				load: dojo.hitch(this, "handleGetLinks"),
				error: dojo.hitch(this, "handleGetLinksError"),
				handleAs: "json"
			});
		},
		
		handleGetLinks: function(data, ioArgs){
			this.defaultRecordUri = data.recordUri;
            var links = data.links || [];
			this.currentLinkItemIds = [];
			var linkDefs = [];
			var getWIURI = dojo.hitch(WorkItemUtil, WorkItemUtil.getViewWorkItemURI || WorkItemUtil.getViewWorkItemUri);
            for (var i = 0; i < links.length; i++) {
				var l = links[i];
				linkDefs.push({
					id: l.id,
					resourceUri: location.protocol + '//' + location.host + net.jazz.ajax._contextRoot + "/resource/itemName/com.ibm.team.workitem.WorkItem/" +  l.id,
					label: l.id + ": " + l.summary,
					href: getWIURI(l.id, null),
					buttonInfo: this._createButtonInfo(l.id)
				});
				this.currentLinkItemIds.push(l.id);
            }
			this._addLinks(linkDefs);
		},
		
		_createButtonInfo: function(id){
			return {
				tooltip: messages.Remove,
				onClick: dojo.hitch(this, function(){
					this._removeItemFromLinksWithConfirm([id]);
				}),
				iconClass: "delete-query-command",
				hoverCommand: true
			};					
		},

		handleGetLinksError: function() {
		},
		
		removeAllLinks: function(){
			this._removeItemFromLinks(null);
		},
		
		_buildProjectAreaMenu: function(parentMenu){
			var subMenu = new dijit.Menu({parentMenu:parentMenu});
			var self = this;
			subMenu.addChild(new dijit.MenuItem({iconClass: "cqLoadingImg_small", label: basemessages.loading}));
			subMenu.connect(subMenu, "onOpen", function(){
				if(!subMenu.domNode || subMenu.menuCreated) return;
				subMenu.menuCreated = true;
				var serviceRequest = new ServiceRequest(PROCESS_SERVICE_URI, "getAllProjectAreas", {hideArchivedProjects: true});
				var srh = new ServiceResponseHandler(self, "_onAllProjectArea", "_noProjectArea");
				TeamServerClient.invokeService(serviceRequest, srh);
			});
			subMenu.startup();
			this.projectAreaListMenu = subMenu;
			this._addPopupMenu(subMenu);
			return subMenu;
		},
		
		_onAllProjectArea: function(projectAreas){
			var subMenu = this.projectAreaListMenu;
			subMenu.destroyDescendants();
			subMenu.focusedChild = null;
			for (var i = 0; i < projectAreas.length; i++) {
				var p = projectAreas[i];
				var newWorkItemMenu = new dijit.PopupMenuItem({
					label: p.name,
					popup:this._buildWorkItemTypeMenu(subMenu, p)
				});
				subMenu.addChild(newWorkItemMenu);
			}		
			subMenu.startup();
		},
		
		_noProjectArea: function(){
		},
	
		_buildWorkItemTypeMenu: function(parentMenu, projectArea){
			var subMenu = new dijit.Menu({parentMenu:parentMenu});
			var self = this;
			subMenu.addChild(new dijit.MenuItem({iconClass: "cqLoadingImg_small", label: basemessages.loading}));
			subMenu.connect(subMenu, "onOpen", function(){
				if(!subMenu.domNode || subMenu.menuCreated) return;
				subMenu.menuCreated = true;
				jazz.client.xhrGet({
					url: SERVICE_PREFIX + WORK_ITEM_REST_SERVICE_URI + "/types/" + projectArea.itemId,
					handleAs: "json",
					headers: {"Accept": "text/json"},
					load: function(data){
						subMenu.destroyDescendants();
						subMenu.focusedChild = null;
						dojo.forEach(data.collection, function(item){
							var workItemType = item.type;
							var newWorkItemMenu = new dijit.MenuItem({
								label: workItemType.name.value,
								iconClass: "cmTasksPartMenuIcon",
								onClick: dojo.hitch(self, function(){
									self.onCreateWorkItem(projectArea, workItemType);
								})
							});
							if(workItemType.iconUrl){
								newWorkItemMenu.iconNode.style.backgroundImage = "url(" + workItemType.iconUrl.value + ")";
							}
							subMenu.addChild(newWorkItemMenu);
						});
						subMenu.startup();
					}
				});
			});
			subMenu.startup();
			this._addPopupMenu(subMenu);
			return subMenu;
		},

		onCreateWorkItem: function(projectArea, workItemType) {
			var projectAreaId = projectArea.itemId;
			var recordUri = this.defaultRecordUri || this._getRecordURL();
			jazz.client.xhrPost({
				url: SERVICE_PREFIX + WORK_ITEM_REST_SERVICE_URI + "/drafts/workitems",
				content: {
					type: "types/" + projectAreaId + "/" + workItemType.identifier.value,
					links: "linkType=" + CMRECORD_LINKTYPE + "&source=false&uri=" + recordUri + "&comment=" + this.recordTitle
				},
				handleAs: "json",
				headers: {"Accept": "text/json"},
				load: dojo.hitch(this, "_newTaskCreated")
			});
		},
		
		_newTaskCreated: function(data){
			var href = data._meta.href;
			// var href = data.documentElement.attributes["href"].value;
			var id = href.substring(href.lastIndexOf("/") + 1); // e.g. "drafts/workitems/_3NLdAAtBEd6ltoo2Aqphsw"
			var ts = new Date().getTime(); 
			document.location = "#action=com.ibm.team.workitem.newWorkItem" + 
				"&draftId=" + encodeURIComponent(id) + 
				"&ts=" + encodeURIComponent(ts);
		}		

	});
    
})();
