/*
 * Licensed Materials - Property of IBM
 * Rational ClearQuest 
 * (C) Copyright IBM Corp. 2009  All Rights Reserved
 * US Government Users Restricted Rights -
 * Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp
 */
 
dojo.provide("com.ibm.rational.cm.web.ui.view.resultset.actions.customizeColumns");

dojo.require("com.ibm.rational.cm.web.ui.view.common.DoubleListBox");

com.ibm.rational.cm.web.ui.view.resultset.actions.showCustomizeDialog = function(/* com.ibm.rational.cm.web.ui.view.resultset.ResultSetView */ widget){
	var dlg = widget._customizeDialog;
	var grid = widget.rsGrid;
	if(!dlg){
		dlg = widget._customizeDialog = new com.ibm.rational.cm.web.ui.view.common.DoubleListBoxDialog({
			title: widget.messages.customizeColumns,
			allowUserValue: false,
			allowOrdering: true,
			addCSH: true
		});
		dlg.execute = function(formContents){
			grid.customizeColumns(dlg.getValueList());
		};
		dlg.resize({ w:520, h:350 });
		dlg.startup();
	}
	var valueList = [];
	var choiceList = [];
	var optionLabelMap = {};
	dojo.forEach(grid._colInfo, function(col){
		if(col.name){
			optionLabelMap[col.field] = col.name;
		}
		if(col.index != -1){
			valueList[col.index] = col.field;
		}else{
			choiceList.push(col.field);
		}
	});
	dlg.setOptionLabelMap(optionLabelMap); // RATLC01361572 : hidden mastership field should not be shown in the result-set customize columns dialog
	dlg.setValueList(valueList);
	dlg.setChoiceList(choiceList);
	dlg.show();		
}
 