/*
 * Licensed Materials - Property of IBM
 * Rational ClearQuest 
 * (C) Copyright IBM Corp. 2009  All Rights Reserved
 * US Government Users Restricted Rights -
 * Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp
 */

dojo.provide("com.ibm.rational.cm.web.ui.view.resultset.actions.multiRecordUpdate");

dojo.require("com.ibm.rational.cm.web._base");

com.ibm.rational.cm.web.ui.view.resultset.actions.loadActions = function(/* com.ibm.rational.cm.web.ui.view.resultset.ResultSetView */ widget){
	var menu = widget.batchMenu;

	// don't fetch if it already requested
	if(menu._isActionLoading){ return; }

	var cq = com.ibm.rational.cm.web;
	cq.xhrGet({
		url: "cqartifactdetails.cq",
		content: {
			action: "GetActionsForRecordType",
			recordType: widget.recordType
		},
		onBegin: function(){
			menu._isActionLoading = true;
		},
		load: function(response, ioArgs){
			// first remove menu items (loading menu)
			dojo.forEach(menu.getChildren(), function(menuItem){
        		menu.removeChild(menuItem);
        	});
        	
			var subMenuItems = [];
			var modifyActions = response.Modify;
			if(modifyActions && modifyActions.length > 0){
				// add modify action menus
				dojo.forEach(modifyActions, function(action){
					menu.addChild(new dijit.MenuItem({
						label: action.DisplayName,
						onClick: function(e){
							var grid = widget.rsGrid;
							var selected = grid.selection.getSelected();
							if(selected.length === 0){
								alert(widget.messages.RecordNotSelected)
								return;
							}
			          		dojo.publish("CQ_BATCH_UPDATE_RECORD", [{
   		   						actionId: action.LocationId,
   		   						actionName: action.DisplayName,
   	   							selectedArtifactIds: dojo.map(selected, function(sel){
									return grid.getCellData(sel, "recordId");
								})
			          		}]);
						}
					}));
				});
			}else{
				// create empty menu if it modify action doesn't exist
				menu.addChild(new dijit.MenuItem({
					label: widget.messages.noActions,
					disabled: true
				}));
			}
			menu._isActionLoading = false;
		},
		error: function(response, ioArgs){
			console.error("Error in /cqweb/cqartifactdetails.cq?action=GetActionsForRecordType: "+response);
		},
		handleError: true,
		preventCache: true
	});
}