/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2007, 2009. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.build.web.util.BuildUtil");

dojo.require("com.ibm.team.build.web.ui.BuildConstants");

(function() {

/*
 * Aliases
 */
var BuildConstants = com.ibm.team.build.web.ui.BuildConstants;

/*
 * Public utility methods.
 */
com.ibm.team.build.web.util.BuildUtil = {
	/*
	 * Returns an HREF to show all build defintions for the current project.
	 */
	/* string */ getDefinitionListHref: function() {
		var href = ["#action=", BuildConstants.ACTION_VIEW_DEFINITION_LIST];
		return href.join("");
	},
	
	/*
	 * Returns an HREF to show information about a build definition.
	 */
	getDefinitionHref: function(/* string */ definitionItemId){
		var href = ["#action=", BuildConstants.ACTION_VIEW_DEFINITION, "&", BuildConstants.URL_PARAM_ID, "=", encodeURIComponent(definitionItemId)];
		return href.join("");
	},
	
	/*
	 * Returns an HREF to show information about a build result.
	 */
	getResultHref: function(/* string */ resultItemId, /* string */ tabId){
		var href = ["#action=", BuildConstants.ACTION_VIEW_RESULT, "&", BuildConstants.URL_PARAM_ID, "=", encodeURIComponent(resultItemId)];
		if (tabId) {
			href.push("&");
			href.push(BuildConstants.URL_PARAM_TAB);
			href.push("=");
			href.push(encodeURIComponent(tabId));
		}
		return href.join("");
	},
	
	/*
	 * Returns an HREF to show the build queue for the current project.
	 */
	getBuildQueueHref: function(){
		var href = ["#action=", BuildConstants.ACTION_VIEW_BUILD_QUEUE];
		return href.join("");
	},
	
	/*
	 * Returns an HREF to request a build for a given build definition.
	 */
	getRequestBuildHref: function(/* string */ definitionItemId) {
		var href = ["#action=", BuildConstants.ACTION_REQUEST_BUILD, "&", BuildConstants.URL_PARAM_DEFINITION, "=", encodeURIComponent(definitionItemId)];
		return href.join("");
	},
	
	/*
	 * Returns an HREF to request a rebuild for a given build result.
	 */
	getRequestRebuildHref: function(/* string */ resultItemId) {
		var href = ["#action=", BuildConstants.ACTION_REQUEST_BUILD, "&", BuildConstants.URL_PARAM_RESULT, "=", encodeURIComponent(resultItemId)];
		return href.join("");
	},
	
	/*
	 * Returns an HREF to show the build engines for the current project.
	 */
	getBuildEnginesHref: function(){
		var href = ["#action=", BuildConstants.ACTION_VIEW_BUILD_ENGINES];
		return href.join("");
	}
};

})();