/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2009. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.apt.client.internal.plancheck.PlanModelCheckReport"); //$NON-NLS-1$

dojo.require("com.ibm.team.apt.client.internal.plancheck.PlanItemCheckReport"); //$NON-NLS-1$

(function() {
	
var PlanItemCheckReport				= com.ibm.team.apt.client.internal.plancheck.PlanItemCheckReport;

dojo.declare("com.ibm.team.apt.client.internal.plancheck.PlanModelCheckReport", null, { //$NON-NLS-1$

	__plan: null,
	__reports: null,
	
	constructor: function(plan) {
		this.__plan= plan;
		this.__reports= {};
	},

	// ---- api ------------------------------------------------------------------------------------------------------------
	
	getPlanElement: function() {
		return this.__plan;
	},
	
	addProblem: function(problem) {
		var report= this.createReport(problem.getPlanElement());
		report.addProblem(problem);
	},
	
	removeEmptyReports: function(problem) {
		for (var elementId in this.__reports) {
			if (!this.__reports[elementId].hasProblems()) {
				delete this.__reports[elementId];
			}
		}
	},
	
	getReports: function() {
		var result= [];
		for (var elementId in this.__reports) {
			result.push(this.__reports[elementId]);
		}
		return result;
	},

	getReport: function(planElement) {
		return this.__reports[planElement.getElementKey()] || null;
	},

	createReport: function(planElement) {
		var result= this.__reports[planElement.getElementKey()];
		if (!result) {
			result= new PlanItemCheckReport(planElement);
			this.__reports[planElement.getElementKey()]= result;
		}
		
		return result;
	},
	
	// ---- implementation -------------------------------------------------------------------------------------------------

	__sentinel: null // terminates this class definition
});


})();
