/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2009. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.apt.common.ContributorAbsence"); //$NON-NLS-1$

//dojo.require("com.ibm.team.apt.internal.client.util.Iterations"); //$NON-NLS-1$
dojo.require("dojo.date.stamp"); //$NON-NLS-1$
dojo.require("com.ibm.team.apt.client.internal.Instant"); //$NON-NLS-1$

(function() {

var Instant							= com.ibm.team.apt.client.internal.Instant;
var DAY_END_OFFSET					= (24 * 60 * 60 * 1000) - 1;


dojo.declare("com.ibm.team.apt.common.ContributorAbsence", null, { //$NON-NLS-1$

	constructor: function(contributorAbsenceDTO) {
		this.itemId= contributorAbsenceDTO.itemId;
		this.itemType= contributorAbsenceDTO.itemType;
		this.label= contributorAbsenceDTO.label;
		this.iconURL= contributorAbsenceDTO.iconURL;
		
		if (contributorAbsenceDTO.startDate != null) {
			var startDate= dojo.date.stamp.fromISOString(contributorAbsenceDTO.startDate);
			startDate.setHours(0);
			startDate.setMinutes(0);
			startDate.setSeconds(0);
			startDate.setMilliseconds(0);
			this.startDate= new Instant(startDate);
		}

		if (contributorAbsenceDTO.endDate != null) {
			var endDate= dojo.date.stamp.fromISOString(contributorAbsenceDTO.endDate);
			endDate.setHours(0);
			endDate.setMinutes(0);
			endDate.setSeconds(0);
			endDate.setMilliseconds(0);
			this.endDate= new Instant(new Date(endDate.getTime() + DAY_END_OFFSET));
		}
	},

	// ---- api ------------------------------------------------------------------------------------------------------------

	itemId: null,
	itemType: null,
	label: null,
	iconURL: null,
	startDate: null,
	endDate: null,
	
	equals: function(other) {
		if (this === other)
			return true;

		if (this.declaredClass !== other.declaredClass)
			return false;
		
		return this.itemId == other.itemId;
	},

	compareTo: function(other) {
		return com.ibm.team.apt.internal.client.util.Iterations.compareTo(this, other);
	},
	
	// ---- implementation -------------------------------------------------------------------------------------------------

	__sentinel: null // terminates this class definition
});


})();
